CREATE DATABASE  IF NOT EXISTS `comptaxm` /*!40100 DEFAULT CHARACTER SET latin1 */;
USE `comptaxm`;
-- MySQL dump 10.13  Distrib 5.5.16, for Win32 (x86)
--
-- Host: localhost    Database: comptaxm
-- ------------------------------------------------------
-- Server version	5.5.28

/*!40101 SET @OLD_CHARACTER_SET_CLIENT=@@CHARACTER_SET_CLIENT */;
/*!40101 SET @OLD_CHARACTER_SET_RESULTS=@@CHARACTER_SET_RESULTS */;
/*!40101 SET @OLD_COLLATION_CONNECTION=@@COLLATION_CONNECTION */;
/*!40101 SET NAMES utf8 */;
/*!40103 SET @OLD_TIME_ZONE=@@TIME_ZONE */;
/*!40103 SET TIME_ZONE='+00:00' */;
/*!40014 SET @OLD_UNIQUE_CHECKS=@@UNIQUE_CHECKS, UNIQUE_CHECKS=0 */;
/*!40014 SET @OLD_FOREIGN_KEY_CHECKS=@@FOREIGN_KEY_CHECKS, FOREIGN_KEY_CHECKS=0 */;
/*!40101 SET @OLD_SQL_MODE=@@SQL_MODE, SQL_MODE='NO_AUTO_VALUE_ON_ZERO' */;
/*!40111 SET @OLD_SQL_NOTES=@@SQL_NOTES, SQL_NOTES=0 */;

--
-- Table structure for table `centre`
--

DROP TABLE IF EXISTS `centre`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `centre` (
  `idcentre` int(11) NOT NULL,
  `idUsuari` int(11) DEFAULT NULL,
  PRIMARY KEY (`idcentre`),
  KEY `fk_centre_persona_idx` (`idcentre`),
  KEY `fk_centre_usuari_idx` (`idUsuari`),
  KEY `FKAEB2CDDBF226508` (`idcentre`),
  KEY `FKAEB2CDDBC2D4D837` (`idUsuari`),
  CONSTRAINT `FKAEB2CDDBC2D4D837` FOREIGN KEY (`idUsuari`) REFERENCES `usuari` (`idusuari`),
  CONSTRAINT `FKAEB2CDDBF226508` FOREIGN KEY (`idcentre`) REFERENCES `persona` (`idpersona`),
  CONSTRAINT `fk_centre_persona` FOREIGN KEY (`idcentre`) REFERENCES `persona` (`idpersona`) ON DELETE CASCADE ON UPDATE CASCADE,
  CONSTRAINT `fk_centre_usuari` FOREIGN KEY (`idUsuari`) REFERENCES `usuari` (`idusuari`) ON DELETE NO ACTION ON UPDATE NO ACTION
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `centre`
--

LOCK TABLES `centre` WRITE;
/*!40000 ALTER TABLE `centre` DISABLE KEYS */;
INSERT INTO `centre` VALUES (8,2),(5,7),(10,9),(11,9),(6,12),(4,13);
/*!40000 ALTER TABLE `centre` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `comanda`
--

DROP TABLE IF EXISTS `comanda`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `comanda` (
  `idComanda` int(11) NOT NULL,
  `idProveidor` int(11) DEFAULT NULL,
  `dia` int(2) NOT NULL,
  PRIMARY KEY (`idComanda`),
  KEY `fk_comanda_proveidor_idx` (`idComanda`),
  KEY `fk_comanda_proveidor_idx1` (`idProveidor`),
  KEY `FK38A09A6B34C0B700` (`idProveidor`),
  KEY `FK38A09A6B4DDFFAEF` (`idComanda`),
  CONSTRAINT `FK38A09A6B34C0B700` FOREIGN KEY (`idProveidor`) REFERENCES `proveidor` (`idProveidor`),
  CONSTRAINT `FK38A09A6B4DDFFAEF` FOREIGN KEY (`idComanda`) REFERENCES `rebut` (`idrebut`),
  CONSTRAINT `fk_comanda_proveidor` FOREIGN KEY (`idProveidor`) REFERENCES `proveidor` (`idProveidor`) ON DELETE NO ACTION ON UPDATE NO ACTION,
  CONSTRAINT `fk_comanda_rebut` FOREIGN KEY (`idComanda`) REFERENCES `rebut` (`idrebut`) ON DELETE NO ACTION ON UPDATE NO ACTION
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `comanda`
--

LOCK TABLES `comanda` WRITE;
/*!40000 ALTER TABLE `comanda` DISABLE KEYS */;
INSERT INTO `comanda` VALUES (4,1,1),(5,1,2),(6,1,3),(7,1,1),(8,2,3),(9,2,4),(10,2,5),(11,3,20),(12,3,30),(13,1,8),(22,8,10),(23,8,5),(25,1,4),(28,7,7),(30,11,7),(32,12,6),(34,14,31),(36,11,6),(38,13,15),(40,19,2),(41,12,2),(42,11,2),(44,17,31),(47,12,3),(49,17,2),(51,21,1),(53,14,29),(55,14,31),(56,NULL,31),(57,NULL,31),(58,8,4),(59,8,1),(63,23,3),(64,26,2),(65,28,2),(66,4,30),(67,30,9),(68,NULL,2),(69,4,1),(70,NULL,25),(74,11,2),(75,11,2),(76,3,2),(78,32,7),(79,9,2),(81,8,1),(82,8,1),(83,1,4);
/*!40000 ALTER TABLE `comanda` ENABLE KEYS */;
UNLOCK TABLES;
/*!50003 SET @saved_cs_client      = @@character_set_client */ ;
/*!50003 SET @saved_cs_results     = @@character_set_results */ ;
/*!50003 SET @saved_col_connection = @@collation_connection */ ;
/*!50003 SET character_set_client  = utf8 */ ;
/*!50003 SET character_set_results = utf8 */ ;
/*!50003 SET collation_connection  = utf8_general_ci */ ;
/*!50003 SET @saved_sql_mode       = @@sql_mode */ ;
/*!50003 SET sql_mode              = 'STRICT_TRANS_TABLES,NO_AUTO_CREATE_USER,NO_ENGINE_SUBSTITUTION' */ ;
DELIMITER ;;
/*!50003 CREATE*/ /*!50017 DEFINER=`root`@`localhost`*/ /*!50003 TRIGGER `comptaxm`.`insertar_total_compte_comanda`
AFTER INSERT ON `comptaxm`.`comanda`
FOR EACH ROW
begin  
declare pc int;
declare e int;	
declare compt int;
declare c double;	
	select idPeriodeComptable into pc  from rebut where idrebut=new.idcomanda;
	select idCompte into compt  from rebut where idrebut=new.idcomanda;	
	select count(*) into e From periodecomptablecompte where idPeriodeComptable=pc and idCompte=compt;
	if(e=0) then 	
		INSERT INTO periodecomptablecompte(idPeriodeComptable,idCompte,totalComanda,totalPrevisio)
			values(pc,compt,0,0);		
	end if;
	
	select valor into c from rebut where idRebut=new.idcomanda;			
	UPDATE periodecomptablecompte set totalcomanda=totalcomanda+c
		WHERE idPeriodeComptable=pc and idCompte=compt;	
end */;;
DELIMITER ;
/*!50003 SET sql_mode              = @saved_sql_mode */ ;
/*!50003 SET character_set_client  = @saved_cs_client */ ;
/*!50003 SET character_set_results = @saved_cs_results */ ;
/*!50003 SET collation_connection  = @saved_col_connection */ ;
/*!50003 SET @saved_cs_client      = @@character_set_client */ ;
/*!50003 SET @saved_cs_results     = @@character_set_results */ ;
/*!50003 SET @saved_col_connection = @@collation_connection */ ;
/*!50003 SET character_set_client  = utf8 */ ;
/*!50003 SET character_set_results = utf8 */ ;
/*!50003 SET collation_connection  = utf8_general_ci */ ;
/*!50003 SET @saved_sql_mode       = @@sql_mode */ ;
/*!50003 SET sql_mode              = 'STRICT_TRANS_TABLES,NO_AUTO_CREATE_USER,NO_ENGINE_SUBSTITUTION' */ ;
DELIMITER ;;
/*!50003 CREATE*/ /*!50017 DEFINER=`root`@`localhost`*/ /*!50003 TRIGGER `comptaxm`.`borrar_total_compte_comanda`
AFTER DELETE ON `comptaxm`.`comanda`
FOR EACH ROW
begin  
declare pc int;
declare e int;	
declare compt int;
declare c double;	
	select idPeriodeComptable into pc  from rebut where idrebut=old.idcomanda;
	select idCompte into compt  from rebut where idrebut=old.idcomanda;		
	select valor into c from rebut where idRebut=old.idcomanda;			
	UPDATE periodecomptablecompte set totalcomanda=totalcomanda-c
		WHERE idPeriodeComptable=pc and idCompte=compt;	
end */;;
DELIMITER ;
/*!50003 SET sql_mode              = @saved_sql_mode */ ;
/*!50003 SET character_set_client  = @saved_cs_client */ ;
/*!50003 SET character_set_results = @saved_cs_results */ ;
/*!50003 SET collation_connection  = @saved_col_connection */ ;

--
-- Table structure for table `compte`
--

DROP TABLE IF EXISTS `compte`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `compte` (
  `idCompte` int(4) NOT NULL AUTO_INCREMENT,
  `codi` varchar(8) NOT NULL,
  `descripcio` varchar(45) NOT NULL,
  `estat` int(1) NOT NULL DEFAULT '1',
  PRIMARY KEY (`idCompte`)
) ENGINE=InnoDB AUTO_INCREMENT=7 DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `compte`
--

LOCK TABLES `compte` WRITE;
/*!40000 ALTER TABLE `compte` DISABLE KEYS */;
INSERT INTO `compte` VALUES (1,'6000001','Compres varies',1),(2,'6000002','Compres Manteniment',1),(3,'7000001','Vendes varies',1),(4,'6220000','Manteniment',1),(5,'6000003','compres',1),(6,'6000004','Compres Extres',1);
/*!40000 ALTER TABLE `compte` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `periodecomptable`
--

DROP TABLE IF EXISTS `periodecomptable`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `periodecomptable` (
  `idperiodeComptable` int(11) NOT NULL AUTO_INCREMENT,
  `mes` int(2) NOT NULL,
  `anyo` int(4) NOT NULL,
  `idcentre` int(11) NOT NULL,
  `estat` int(1) NOT NULL DEFAULT '1',
  PRIMARY KEY (`idperiodeComptable`),
  KEY `fk_periode_centre_idx` (`idperiodeComptable`),
  KEY `FK190937DB510FA0EA` (`idcentre`),
  CONSTRAINT `FK190937DB510FA0EA` FOREIGN KEY (`idcentre`) REFERENCES `centre` (`idcentre`),
  CONSTRAINT `fk_periode_centre` FOREIGN KEY (`idcentre`) REFERENCES `centre` (`idcentre`) ON DELETE NO ACTION ON UPDATE NO ACTION
) ENGINE=InnoDB AUTO_INCREMENT=50 DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `periodecomptable`
--

LOCK TABLES `periodecomptable` WRITE;
/*!40000 ALTER TABLE `periodecomptable` DISABLE KEYS */;
INSERT INTO `periodecomptable` VALUES (1,1,2012,4,1),(2,2,2012,4,1),(3,3,2012,4,1),(4,1,2012,5,0),(5,2,2012,5,0),(6,3,2012,5,0),(7,1,2012,6,0),(8,2,2012,6,0),(9,3,2012,6,1),(10,1,2012,8,0),(11,4,2012,8,0),(12,4,2012,5,1),(13,4,2012,6,1),(14,4,2012,4,1),(15,4,2012,10,1),(16,1,2012,10,0),(17,3,2012,8,1),(18,3,2012,10,0),(19,2,2012,8,1),(20,2,2012,10,0),(21,5,2012,8,1),(22,5,2012,5,1),(23,5,2012,10,1),(24,5,2012,6,1),(25,5,2012,4,1),(26,6,2012,8,1),(27,6,2012,5,1),(28,6,2012,10,1),(29,6,2012,6,1),(30,6,2012,4,1),(31,12,2012,8,1),(32,12,2012,5,1),(33,12,2012,10,1),(34,12,2012,6,1),(35,12,2012,4,1),(36,12,2012,11,1),(37,3,2013,4,1),(38,1,2013,8,1),(39,1,2013,5,1),(40,1,2013,10,1),(41,1,2013,6,1),(42,1,2013,4,1),(43,1,2013,11,1),(44,3,2012,11,1),(45,4,2013,8,0),(46,4,2013,5,0),(47,4,2013,6,0),(48,4,2013,4,0),(49,4,2013,11,0);
/*!40000 ALTER TABLE `periodecomptable` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `periodecomptablecompte`
--

DROP TABLE IF EXISTS `periodecomptablecompte`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `periodecomptablecompte` (
  `idPeriodeComptableCompte` int(11) NOT NULL AUTO_INCREMENT,
  `idPeriodeComptable` int(11) NOT NULL,
  `idCompte` int(4) NOT NULL,
  `totalPrevisio` double(10,2) NOT NULL DEFAULT '0.00',
  `totalComanda` double(10,2) NOT NULL DEFAULT '0.00',
  PRIMARY KEY (`idPeriodeComptableCompte`),
  KEY `FKD537DD5B46A0A3CA` (`idPeriodeComptable`),
  KEY `FKD537DD5B522870B4` (`idCompte`),
  CONSTRAINT `FKD537DD5B46A0A3CA` FOREIGN KEY (`idPeriodeComptable`) REFERENCES `periodecomptable` (`idperiodeComptable`),
  CONSTRAINT `FKD537DD5B522870B4` FOREIGN KEY (`idCompte`) REFERENCES `compte` (`idCompte`),
  CONSTRAINT `fk_periodecomptablecompte_Compte` FOREIGN KEY (`idCompte`) REFERENCES `compte` (`idCompte`) ON DELETE NO ACTION ON UPDATE CASCADE,
  CONSTRAINT `fk_periodecomptablecompte_periodeComptable` FOREIGN KEY (`idPeriodeComptable`) REFERENCES `periodecomptable` (`idperiodeComptable`) ON DELETE NO ACTION ON UPDATE NO ACTION
) ENGINE=InnoDB AUTO_INCREMENT=40 DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `periodecomptablecompte`
--

LOCK TABLES `periodecomptablecompte` WRITE;
/*!40000 ALTER TABLE `periodecomptablecompte` DISABLE KEYS */;
INSERT INTO `periodecomptablecompte` VALUES (9,1,1,3000.00,0.00),(10,1,3,2700.00,9000.00),(11,3,3,1000.25,1000.25),(12,3,1,2000.50,1000.25),(13,1,2,0.00,2500.00),(14,2,1,15000.00,16000.00),(15,2,3,0.00,11500.00),(16,3,2,0.00,1000.25),(17,4,1,4500.00,1500.00),(18,10,4,1500.00,3510.15),(19,1,4,6000.00,150.00),(20,4,4,521.15,600.00),(21,16,4,300.00,500.00),(22,20,2,1500.00,1450.00),(23,20,4,1500.00,2203.00),(24,16,3,15000.00,15275.00),(25,18,4,4900.00,5410.00),(26,15,4,5000.00,2950.00),(27,16,2,200.00,195.00),(28,20,3,16750.00,17800.00),(29,18,3,17500.00,22000.00),(30,10,1,0.00,22.00),(31,27,4,5631.00,15993.93),(32,27,3,95800.00,98520.00),(33,27,1,385.00,358.00),(34,33,1,153537.00,26038.00),(35,7,1,0.00,1500.00),(36,12,1,0.00,0.00),(37,25,4,0.00,6000.00),(38,37,1,0.00,0.00),(39,31,1,1500.00,3000.00);
/*!40000 ALTER TABLE `periodecomptablecompte` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `persona`
--

DROP TABLE IF EXISTS `persona`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `persona` (
  `idpersona` int(11) NOT NULL AUTO_INCREMENT,
  `document` varchar(10) NOT NULL,
  `nom` varchar(45) NOT NULL,
  `cognom1` varchar(45) DEFAULT NULL,
  `cognom2` varchar(45) DEFAULT NULL,
  `direccio` varchar(100) DEFAULT NULL,
  `ciutat` varchar(100) DEFAULT NULL,
  `telefon` varchar(10) DEFAULT NULL,
  `email` varchar(100) DEFAULT NULL,
  `estat` int(1) NOT NULL DEFAULT '1',
  PRIMARY KEY (`idpersona`),
  UNIQUE KEY `DOCUMENT_UNIQUE` (`document`)
) ENGINE=InnoDB AUTO_INCREMENT=14 DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `persona`
--

LOCK TABLES `persona` WRITE;
/*!40000 ALTER TABLE `persona` DISABLE KEYS */;
INSERT INTO `persona` VALUES (1,'40305437f','xavier','marti','moret','crta sant feliu','llambilles','972456852','hfjsh@jfklsaj.com',1),(2,'40305438f','Nuri','isern','canals','crta Palamos,4','flaçà','972458520','isern74@gamil.com',1),(3,'40305439f','pepet','marti','','','','','',1),(4,'4111','Secat termic',NULL,NULL,'','Banyoles','','',1),(5,'4020','edar terri',NULL,NULL,'','Banyoles','','',1),(6,'4021','Secat montornes',NULL,NULL,'','Montornes','','',0),(7,'40305431','Sunsi','','','','','','',1),(8,'4026','Edar Serinyà',NULL,NULL,'','','','',1),(9,'77920091','Sergi','','','','','','',1),(10,'4363','LIXIVIATS',NULL,NULL,'','','','',1),(11,'4661','UTE MONTSIA',NULL,NULL,'','','','',1),(12,'4032115','Benet','','','','','','',1),(13,'1234','NURI X','','','','','','',1);
/*!40000 ALTER TABLE `persona` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `previsio`
--

DROP TABLE IF EXISTS `previsio`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `previsio` (
  `idprevisio` int(11) NOT NULL,
  PRIMARY KEY (`idprevisio`),
  KEY `fk_previsio_rebut_idx` (`idprevisio`),
  KEY `FKB413C8838226DC9D` (`idprevisio`),
  CONSTRAINT `FKB413C8838226DC9D` FOREIGN KEY (`idprevisio`) REFERENCES `rebut` (`idrebut`),
  CONSTRAINT `fk_previsio_rebut` FOREIGN KEY (`idprevisio`) REFERENCES `rebut` (`idrebut`) ON DELETE CASCADE ON UPDATE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `previsio`
--

LOCK TABLES `previsio` WRITE;
/*!40000 ALTER TABLE `previsio` DISABLE KEYS */;
INSERT INTO `previsio` VALUES (1),(2),(3),(14),(15),(16),(17),(18),(19),(20),(21),(24),(26),(27),(29),(31),(33),(37),(39),(43),(45),(46),(50),(52),(54),(60),(61),(62),(71),(72),(73),(80);
/*!40000 ALTER TABLE `previsio` ENABLE KEYS */;
UNLOCK TABLES;
/*!50003 SET @saved_cs_client      = @@character_set_client */ ;
/*!50003 SET @saved_cs_results     = @@character_set_results */ ;
/*!50003 SET @saved_col_connection = @@collation_connection */ ;
/*!50003 SET character_set_client  = utf8 */ ;
/*!50003 SET character_set_results = utf8 */ ;
/*!50003 SET collation_connection  = utf8_general_ci */ ;
/*!50003 SET @saved_sql_mode       = @@sql_mode */ ;
/*!50003 SET sql_mode              = 'STRICT_TRANS_TABLES,NO_AUTO_CREATE_USER,NO_ENGINE_SUBSTITUTION' */ ;
DELIMITER ;;
/*!50003 CREATE*/ /*!50017 DEFINER=`root`@`localhost`*/ /*!50003 TRIGGER `comptaxm`.`insertar_total_compte_previsio`
AFTER INSERT ON `comptaxm`.`previsio`
FOR EACH ROW
begin  
declare pc int;
declare e int;	
declare compt int;
declare c double;	
	select idPeriodeComptable into pc  from rebut where idrebut=new.idprevisio;
	select idCompte into compt  from rebut where idrebut=new.idprevisio;	
	select count(*) into e From periodecomptablecompte where idPeriodeComptable=pc and idCompte=compt;
	if(e=0) then 	
		INSERT INTO periodecomptablecompte(idPeriodeComptable,idCompte,totalComanda,totalPrevisio)
			values(pc,compt,0,0);		
	end if;
	
	select valor into c from rebut where idRebut=new.idprevisio;			
	UPDATE periodecomptablecompte set totalprevisio=totalprevisio+c
		WHERE idPeriodeComptable=pc and idCompte=compt;	
end */;;
DELIMITER ;
/*!50003 SET sql_mode              = @saved_sql_mode */ ;
/*!50003 SET character_set_client  = @saved_cs_client */ ;
/*!50003 SET character_set_results = @saved_cs_results */ ;
/*!50003 SET collation_connection  = @saved_col_connection */ ;
/*!50003 SET @saved_cs_client      = @@character_set_client */ ;
/*!50003 SET @saved_cs_results     = @@character_set_results */ ;
/*!50003 SET @saved_col_connection = @@collation_connection */ ;
/*!50003 SET character_set_client  = utf8 */ ;
/*!50003 SET character_set_results = utf8 */ ;
/*!50003 SET collation_connection  = utf8_general_ci */ ;
/*!50003 SET @saved_sql_mode       = @@sql_mode */ ;
/*!50003 SET sql_mode              = 'STRICT_TRANS_TABLES,NO_AUTO_CREATE_USER,NO_ENGINE_SUBSTITUTION' */ ;
DELIMITER ;;
/*!50003 CREATE*/ /*!50017 DEFINER=`root`@`localhost`*/ /*!50003 TRIGGER `comptaxm`.`borra_total_compte_previsio`
AFTER DELETE ON `comptaxm`.`previsio`
FOR EACH ROW
begin  
declare c long;	
declare pc  integer;
declare compt long;
	select valor into c  from rebut where idrebut=old.idprevisio;
	select idPeriodeComptable into pc  from rebut where idrebut=old.idprevisio;
	select idCompte into compt  from rebut where idrebut=old.idprevisio;	

		UPDATE periodecomptablecompte set totalprevisio=totalprevisio-c 
		WHERE idPeriodeComptable=pc and idCompte=compt;

end */;;
DELIMITER ;
/*!50003 SET sql_mode              = @saved_sql_mode */ ;
/*!50003 SET character_set_client  = @saved_cs_client */ ;
/*!50003 SET character_set_results = @saved_cs_results */ ;
/*!50003 SET collation_connection  = @saved_col_connection */ ;

--
-- Table structure for table `proveidor`
--

DROP TABLE IF EXISTS `proveidor`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `proveidor` (
  `idProveidor` int(11) NOT NULL AUTO_INCREMENT,
  `document` varchar(10) NOT NULL,
  `nom` varchar(45) NOT NULL,
  `cognom1` varchar(45) DEFAULT NULL,
  `cognom2` varchar(45) DEFAULT NULL,
  `direccio` varchar(100) DEFAULT NULL,
  `ciutat` varchar(100) DEFAULT NULL,
  `telefon` varchar(10) DEFAULT NULL,
  `email` varchar(100) DEFAULT NULL,
  `idCentre` int(11) NOT NULL,
  `estat` int(1) NOT NULL DEFAULT '1',
  PRIMARY KEY (`idProveidor`),
  KEY `fk_proveidor_idx` (`idProveidor`),
  KEY `fk_proveidor_centre_idx` (`idCentre`),
  KEY `FK853EAC3A510FA0EA` (`idCentre`),
  CONSTRAINT `FK853EAC3A510FA0EA` FOREIGN KEY (`idCentre`) REFERENCES `centre` (`idcentre`),
  CONSTRAINT `fk_proveidor_centre` FOREIGN KEY (`idCentre`) REFERENCES `centre` (`idcentre`) ON DELETE NO ACTION ON UPDATE NO ACTION
) ENGINE=InnoDB AUTO_INCREMENT=33 DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `proveidor`
--

LOCK TABLES `proveidor` WRITE;
/*!40000 ALTER TABLE `proveidor` DISABLE KEYS */;
INSERT INTO `proveidor` VALUES (1,'40305443f','proveidor1',NULL,NULL,NULL,'Girona',NULL,NULL,4,1),(2,'40305444f','proveidor2',NULL,NULL,NULL,'celrà',NULL,NULL,5,1),(3,'40305445f','proveidor3',NULL,NULL,NULL,'celrà',NULL,NULL,6,1),(4,'1255','proveidor','','','','','','',5,1),(5,'1255','proveidor','','','','','','',6,1),(6,'1255','proveidor','','','','','','',4,1),(7,'40512512A','Armé','','','','','','',5,1),(8,'40512512A','Armé','','','','','','',8,1),(9,'1234','nuri','xifra','simon','veïnat mas ferran','Cornellà','972594603','assecat.terri@oms-sacede.es',4,1),(10,'40512512A','Armé','','','','','','',10,0),(11,'B17570912','ARMÉ','','','','','','',10,1),(12,'B17039124','MANXA','','','','','','',10,1),(13,'A08631020','CHEMIPOL','','','','','','',10,1),(14,'P6700010I','Consell Comarcal del Pla de l\'Estany','','','','','','',10,1),(15,'A91948077','ENDESA','','','','','','',10,1),(16,'A91948077','ENDESA','','','','','','',11,1),(17,'A61893871','FACTOR ENERGIA','','','','','','',10,1),(18,'A61893871','FACTOR ENERGIA','','','','','','',11,1),(19,'B17431875','MAPEL','','','','','','',10,1),(20,'B17431875','MAPEL','','','','','','',11,1),(21,'B17473190','PETROESTANY','','','','','','',10,1),(22,'B17473190','PETROESTANY','','','','','','',11,1),(23,'41151515A','Micropower','','','','','','',5,1),(24,'48751254A','COIET','','','','','','',5,1),(25,'48751254A','COIET','','','','','','',8,1),(26,'59845784','Brammer','','','','','','',5,1),(27,'59845784','Brammer','','','','','','',8,1),(28,'85485478','Mapel','','','','','','',5,1),(29,'85485478','Mapel','','','','','','',8,1),(30,'85478541S','CECAM','','','','','','',5,1),(31,'85478541S','CECAM','','','','','','',8,1),(32,'78','MWM','','','','','','',4,1);
/*!40000 ALTER TABLE `proveidor` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `rebut`
--

DROP TABLE IF EXISTS `rebut`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `rebut` (
  `idrebut` int(11) NOT NULL,
  `descripcio` varchar(100) NOT NULL,
  `idperiodeComptable` int(11) NOT NULL,
  `valor` double(10,2) NOT NULL DEFAULT '0.00',
  `idCompte` int(4) NOT NULL,
  PRIMARY KEY (`idrebut`),
  KEY `fk_rebut_periode_idx` (`idperiodeComptable`),
  KEY `fk_rebut_compte_idx` (`idCompte`),
  KEY `FK675DF6E46A0A3CA` (`idperiodeComptable`),
  KEY `FK675DF6E522870B4` (`idCompte`),
  CONSTRAINT `FK675DF6E46A0A3CA` FOREIGN KEY (`idperiodeComptable`) REFERENCES `periodecomptable` (`idperiodeComptable`),
  CONSTRAINT `FK675DF6E522870B4` FOREIGN KEY (`idCompte`) REFERENCES `compte` (`idCompte`),
  CONSTRAINT `fk_rebut_compte` FOREIGN KEY (`idCompte`) REFERENCES `compte` (`idCompte`) ON DELETE NO ACTION ON UPDATE CASCADE,
  CONSTRAINT `fk_rebut_periode` FOREIGN KEY (`idperiodeComptable`) REFERENCES `periodecomptable` (`idperiodeComptable`) ON DELETE NO ACTION ON UPDATE NO ACTION
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `rebut`
--

LOCK TABLES `rebut` WRITE;
/*!40000 ALTER TABLE `rebut` DISABLE KEYS */;
INSERT INTO `rebut` VALUES (1,'Previsio1',1,1500.00,1),(2,'compra1',1,1500.00,1),(3,'Previsio de vendes varies',1,1500.00,3),(4,'compra1',1,1000.00,2),(5,'compra1',1,9000.00,3),(6,'compra1',1,1500.00,2),(7,'compra1',2,1500.00,1),(8,'compra1',2,1500.00,3),(9,'compra1',2,1000.00,3),(10,'compra1',2,9000.00,3),(11,'compra2',3,1000.25,3),(12,'compra2',3,1000.25,1),(13,'compra2',3,1000.25,2),(14,'compra2',3,1000.25,3),(15,'compra2',3,1000.25,1),(16,'compra2',3,1000.25,1),(17,'segona previsio',1,1200.00,3),(18,'Presvisio',4,1500.00,1),(19,'Previsió ',4,1500.00,1),(20,'Presvisio',4,1500.00,1),(21,'Bomba Flyft',10,1500.00,4),(22,'Bomba Flyft',10,1500.00,4),(23,'Rodet bomba espessidor',10,780.15,4),(24,'sdagfasj',2,15000.00,1),(25,'jfklsj',2,14500.00,1),(26,'MWM',1,6000.00,4),(27,'Acoplament bomba purga bio nº1',4,521.15,4),(28,'Acoplament bomba purga bio nº1',4,600.00,4),(29,'Oli bufants',16,300.00,4),(30,'Oli',16,500.00,4),(31,'mant',20,1500.00,4),(32,'Material',20,350.00,4),(33,'CCPE',16,15000.00,3),(34,'Factura Explotació Mes Gener',16,15275.00,3),(36,'Reparació bomba',20,1853.00,4),(37,'REACTIUS',20,1500.00,2),(38,'ANTIESPUMANT',20,1450.00,2),(39,'MATERIAL VARI',18,2000.00,4),(40,'MATERIAL',18,400.00,4),(41,'MATERIAL',18,210.00,4),(42,'BOMBA NOVA',18,1800.00,4),(43,'ELECTRICITAT',18,2900.00,4),(44,'CONSUM ELÈCTRIC',18,3000.00,4),(45,'ELECTRICITAT',15,3000.00,4),(46,'VARIS',15,2000.00,4),(47,'MATERIAL',15,50.00,4),(49,'CONSUM ELÈCTRIC MARÇ',15,2900.00,4),(50,'GASOIL',16,200.00,2),(51,'GASOIL',16,195.00,2),(52,'FACTURA EXPLOTACIÓ FEBRER',20,16750.00,3),(53,'FACTURACIÓ EXPLOTACIÓ FEBRER\'12',20,17800.00,3),(54,'FACTURACIÓ EXPLOTACIÓ',18,17500.00,3),(55,'FACTURACIÓ EXPLOTACIÓ MARÇ\'12',18,17800.00,3),(56,'FACTURA CAP PLANTA A UTE',18,2100.00,3),(57,'FACTURA CAP PLANTA A UTE',18,2100.00,3),(58,'kjhkljjlk',10,1230.00,4),(59,'jhjih',10,10.00,1),(60,'Manteniment mes de Juny',27,5631.00,4),(61,'Venta mes de Juny',27,95800.00,3),(62,'Obres de Juny',27,385.00,1),(63,'Manteniment mes de Juny',27,15845.00,4),(64,'Coixinets de Digestor',27,59.48,4),(65,'Flourescents',27,89.45,4),(66,'Venta mes de Juny',27,98520.00,3),(67,'Analitiques maig',27,358.00,1),(68,'sad',10,12.00,1),(69,'<zz',4,1500.00,1),(70,'compra desembre',33,12356.00,1),(71,'previsio desembre',33,152022.00,1),(72,'una altra',33,15.00,1),(73,'tercera',33,1500.00,1),(74,'comptra varis',33,12230.00,1),(75,'segona compra',33,1452.00,1),(76,'Compra d\'un motor.',7,1500.00,1),(78,'MANTENIMENT MOTORS',25,6000.00,4),(79,'varis',37,0.00,1),(80,'gfhsaj',31,1500.00,1),(81,'kjsdhfjksahk',31,1500.00,1),(82,'qrtrq',31,1500.00,1),(83,'fdsa',1,150.00,4);
/*!40000 ALTER TABLE `rebut` ENABLE KEYS */;
UNLOCK TABLES;
/*!50003 SET @saved_cs_client      = @@character_set_client */ ;
/*!50003 SET @saved_cs_results     = @@character_set_results */ ;
/*!50003 SET @saved_col_connection = @@collation_connection */ ;
/*!50003 SET character_set_client  = utf8 */ ;
/*!50003 SET character_set_results = utf8 */ ;
/*!50003 SET collation_connection  = utf8_general_ci */ ;
/*!50003 SET @saved_sql_mode       = @@sql_mode */ ;
/*!50003 SET sql_mode              = 'STRICT_TRANS_TABLES,NO_AUTO_CREATE_USER,NO_ENGINE_SUBSTITUTION' */ ;
DELIMITER ;;
/*!50003 CREATE*/ /*!50017 DEFINER=`root`@`localhost`*/ /*!50003 TRIGGER `comptaxm`.`modifica_total_compte_rebut`
AFTER UPDATE ON `comptaxm`.`rebut`
FOR EACH ROW
begin  
declare c long;	
	select count(*) into c from comanda where idComanda=new.idrebut;
	IF(c>0 )THEN
		UPDATE periodecomptablecompte set totalComanda=totalComanda-old.valor 
		WHERE idPeriodeComptable=NEW.idPeriodeComptable and idCompte=old.idCompte;
		select count(*) into c from periodecomptablecompte 
		where idPeriodeComptable=NEW.idPeriodeComptable and idCompte=new.idCompte;
		IF(c>0) THEN 
			UPDATE periodecomptablecompte set totalComanda=totalComanda+new.valor
			WHERE idPeriodeComptable=NEW.idPeriodeComptable and idCompte=new.idCompte;
		ELSE
			INSERT INTO periodecomptablecompte(idperiodecomptable,idcompte,totalComanda)
			VALUES(NEW.idperiodeComptable,NEW.idcompte,new.valor);
		end if;
	end if;
	select count(*) into c from previsio where idPrevisio=new.idrebut;
	IF(c>0 )THEN	
		UPDATE periodecomptablecompte set totalPrevisio=totalPrevisio-OLD.valor
		WHERE idPeriodeComptable=NEW.idPeriodeComptable and idCompte=OLD.idCompte;
		select count(*) into c from periodecomptablecompte 
		where idPeriodeComptable=NEW.idPeriodeComptable and idCompte=new.idCompte;
		IF(c>0) THEN 
			UPDATE periodecomptablecompte set totalPrevisio=totalPrevisio+new.valor
			WHERE idPeriodeComptable=NEW.idPeriodeComptable and idCompte=new.idCompte;
		ELSE
			INSERT INTO periodecomptablecompte(idperiodecomptable,idCompte,totalPrevisio)
			VALUES(NEW.idperiodeComptable,NEW.idCompte,new.valor);
		end if;
	END IF;
end */;;
DELIMITER ;
/*!50003 SET sql_mode              = @saved_sql_mode */ ;
/*!50003 SET character_set_client  = @saved_cs_client */ ;
/*!50003 SET character_set_results = @saved_cs_results */ ;
/*!50003 SET collation_connection  = @saved_col_connection */ ;

--
-- Table structure for table `usuari`
--

DROP TABLE IF EXISTS `usuari`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `usuari` (
  `idusuari` int(11) NOT NULL,
  `login` varchar(45) NOT NULL,
  `password` varchar(45) NOT NULL,
  `tipusUsuari` varchar(3) NOT NULL DEFAULT 'cap',
  PRIMARY KEY (`idusuari`),
  UNIQUE KEY `login_UNIQUE` (`login`),
  KEY `fk_usuari_persona_idx` (`idusuari`),
  KEY `FKCE3239612EA1D08E` (`idusuari`),
  CONSTRAINT `FKCE3239612EA1D08E` FOREIGN KEY (`idusuari`) REFERENCES `persona` (`idpersona`),
  CONSTRAINT `fk_usuari_persona` FOREIGN KEY (`idusuari`) REFERENCES `persona` (`idpersona`) ON DELETE CASCADE ON UPDATE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `usuari`
--

LOCK TABLES `usuari` WRITE;
/*!40000 ALTER TABLE `usuari` DISABLE KEYS */;
INSERT INTO `usuari` VALUES (1,'admin','admin','adm'),(2,'user','user','cap'),(3,'user1','user1','cap'),(7,'Sunsi','596016','cap'),(9,'Sergi','4363','cap'),(12,'benet','benet','cap'),(13,'NURIX','NURIX','cap');
/*!40000 ALTER TABLE `usuari` ENABLE KEYS */;
UNLOCK TABLES;
/*!40103 SET TIME_ZONE=@OLD_TIME_ZONE */;

/*!40101 SET SQL_MODE=@OLD_SQL_MODE */;
/*!40014 SET FOREIGN_KEY_CHECKS=@OLD_FOREIGN_KEY_CHECKS */;
/*!40014 SET UNIQUE_CHECKS=@OLD_UNIQUE_CHECKS */;
/*!40101 SET CHARACTER_SET_CLIENT=@OLD_CHARACTER_SET_CLIENT */;
/*!40101 SET CHARACTER_SET_RESULTS=@OLD_CHARACTER_SET_RESULTS */;
/*!40101 SET COLLATION_CONNECTION=@OLD_COLLATION_CONNECTION */;
/*!40111 SET SQL_NOTES=@OLD_SQL_NOTES */;

-- Dump completed on 2012-12-16 22:21:35
