package uoc.tfc.xmartimo.action.connexio;


import java.util.Map;

import uoc.tfc.xmartimo.bean.connexio.Usuari;
import uoc.tfc.xmartimo.bean.connexio.UsuariHabilitat;

import com.opensymphony.xwork2.Action;
import com.opensymphony.xwork2.ActionInvocation;
import com.opensymphony.xwork2.interceptor.AbstractInterceptor;

/**
 * Interceptor per controlar l'estat de la sessi i el control d'accs de l'usuari.
 * 
 * @author Xavier Mart Moret UOC.TFC.J2EE.
 *
 */
@SuppressWarnings("serial")
public class IdentificacioInterceptor extends AbstractInterceptor{

    /**
     * Metode executat abans de l'accio  
     */
	
      public void init() 
      { 
          
      }

      /**
       * Interceptor: Redirigeix a l'acci corresponen. 
       * Si l'usuari est activat, rederigeix a l'acci correcte
       * En cas contrari retorna l'usuari a la pantalla login
       */
      public String intercept(ActionInvocation invocation) throws Exception 
      {                 
    		Map<String,Object> session=invocation.getInvocationContext().getSession();
    		Usuari usuari=(Usuari) session.get("usuari");    		
    		if(usuari==null) 
            { 
            	  return Action.LOGIN;
            } 
            else 
            { 
            	  Action action =(Action) invocation.getAction();                        	          			
          			if (action instanceof UsuariHabilitat) {
          				((UsuariHabilitat) action).setUsuari(usuari);
          			}
          			return invocation.invoke();
          		
            }
      }

      /**
       * Destroy. Mtode a executar-se desprs de l'acci.
       */
      public void destroy() 
      { 
         
      }
}