package uoc.tfc.xmartimo.action.connexio;

import java.util.ArrayList;
import java.util.Collection;
import java.util.List;
import java.util.Map;

import org.apache.struts2.interceptor.SessionAware;

import uoc.tfc.xmartimo.bean.connexio.Usuari;
import uoc.tfc.xmartimo.bean.connexio.UsuariHabilitat;

import uoc.tfc.xmartimo.model.connexio.UsuariModel;

import com.opensymphony.xwork2.ActionSupport;
/**
 * UsuariAction. Accions sobre la gesti dels usuaris. <br>
 * Permet presentar, afegir, modificar, donar de baixa usuaris
 * @author Xavier Mart Moret TFC.J2EE
 *
 */
public class UsuariAction extends ActionSupport implements SessionAware,UsuariHabilitat {
	private static final long serialVersionUID = 1L;
	private Map<String,Object> session;
    private UsuariModel usuariModel;
    private Usuari usuari;
    private int idUsuariActual;
    private Usuari usuariActual;
    private List<Usuari>usuarisSistema= new ArrayList<Usuari>();
    private int tipusOperacio;
    private List<String> listTipusUsuari= new ArrayList<String>();
    private String tipusUsuariActual;
    private List<String> errorsComptaXM= new ArrayList<String>();
    private int opcioMenu; 
    private String rePassword;
    private String titol;

	public UsuariAction(){
		this.usuariModel=new UsuariModel();
		
	}
    
    /**
	 * @return the session
	 */
	public Map<String, Object> getSession() {
		return session;
	}

	/**
	 * @param session the session to set
	 */
	public void setSession(Map<String, Object> session) {
		this.session = session;
	}

	/**
	 * @return the usuariModel
	 */
	public UsuariModel getUsuariModel() {
		return usuariModel;
	}

	/**
	 * @param usuariModel the usuariModel to set
	 */
	public void setUsuariModel(UsuariModel usuariModel) {
		this.usuariModel = usuariModel;
	}

	/**
	 * @return the usuari
	 */
	public Usuari getUsuari() {
		return usuari;
	}

	/**
	 * @param usuari the usuari to set
	 */
	public void setUsuari(Usuari usuari) {
		this.usuari = usuari;
	}

	/**
	 * @return the usuaris
	 */
	

	public int getIdUsuariActual() {
		return idUsuariActual;
	}

	public void setIdUsuariActual(int idUsuariActual) {
		this.idUsuariActual = idUsuariActual;
	}
	public List<Usuari> getUsuarisSistema() {
		return usuarisSistema;
	}

	public void setUsuarisSistema(List<Usuari> usuarisSistema) {
		this.usuarisSistema = usuarisSistema;
	}
	
	public Usuari getUsuariActual() {
		return usuariActual;
	}

	public void setUsuariActual(Usuari usuariActual) {
		this.usuariActual = usuariActual;
	}
	public int getTipusOperacio() {
		return tipusOperacio;
	}

	public void setTipusOperacio(int tipusOperacio) {
		this.tipusOperacio = tipusOperacio;
	}

    /**
	 * @return the rePassword
	 */
	public String getRePassword() {
		return rePassword;
	}

	/**
	 * @param rePassword the rePassword to set
	 */
	public void setRePassword(String rePassword) {
		this.rePassword = rePassword;
	}
	public List<String> getListTipusUsuari() {
		return listTipusUsuari;
	}

	public void setListTipusUsuari(List<String> listTipusUsuari) {
		this.listTipusUsuari = listTipusUsuari;
	}

	public String getTipusUsuariActual() {
		return tipusUsuariActual;
	}

	public void setTipusUsuariActual(String tipusUsuariActual) {
		this.tipusUsuariActual = tipusUsuariActual;
	}

	public List<String> getErrorsComptaXM() {
		return errorsComptaXM;
	}

	public void setErrorsComptaXM(List<String> errorsComptaXM) {
		this.errorsComptaXM = errorsComptaXM;
	}
	
	/**
	 * Acci que cerca els usuaris existents el sistema
	 * @return SUCCESS, predeterminada
	 */
	public String obtenirUsuaris(){
		this.titol=getText("usuari.titol.index");
		usuarisSistema= usuariModel.getUsuaris();		
		return SUCCESS;
	}
	
	/**
	 * Acci que dona de baixa un usuari actiu
	 * @return SUCCESS, predeterminada
	 */
	public String baixaUsuari(){
		usuariActual=usuariModel.getUserById(idUsuariActual);
		session.put("modificarEstat", usuariActual);
		session.put("accio", 0);		
		return SUCCESS;
	}
	/**
	 * Acci que dona d'alta un usuari que est de baixa.
	 * @return SUCCESS, predeterminada.
	 */
	public String altaUsuari(){
		usuariActual=usuariModel.getUserById(idUsuariActual);
		session.put("modificarEstat", usuariActual);
		session.put("accio", 1);				
		
		return SUCCESS;
	}
	/**
	 * Acci que afegeix un nou usuari al sistema
	 * @return SUCCESS, predeterminada
	 */
	@SuppressWarnings("unchecked")
	public String afegirUsuari(){
		this.titol=getText("usuari.titol.index");
		setErrorsComptaXM((List<String>) session.get("errorsComptaXM"));
		session.put("errorsComptaXM", new ArrayList<String>());
		listTipusUsuari=new ArrayList<String>();
		listTipusUsuari.add(getText("usuari.tipus.administrador"));
		listTipusUsuari.add(getText("usuari.tipus.capplanta"));
		
		if(errorsComptaXM==null){
			usuariActual= new Usuari();
					
			tipusUsuariActual=""; 
		}
		return SUCCESS;
	}
	/**
	 * Acci que modifica un usuari del sistema. 
	 * @return SUCCESS, predeterminada
	 */
	@SuppressWarnings("unchecked")
	public String modificarUsuari(){
		this.titol=getText("usuari.titol.index");
		setErrorsComptaXM((List<String>) session.get("errorsComptaXM"));
		session.put("errorsComptaXM", new ArrayList<String>());
		listTipusUsuari=new ArrayList<String>();
		listTipusUsuari.add(getText("usuari.tipus.administrador"));
		listTipusUsuari.add(getText("usuari.tipus.capplanta"));
		
		if(errorsComptaXM!=null){
			if(errorsComptaXM.size()>0){
				return SUCCESS;
			}
		}
			usuariActual= usuariModel.getUserById(idUsuariActual);
			if (usuariActual.getTipusUsuari().equals(usuariActual.getAdministrador())){
				tipusUsuariActual=getText("usuari.tipus.administrador");
			}else{
				tipusUsuariActual=getText("usuari.tipus.capplanta");
			}
			 
		
		return SUCCESS;
	}
	/**
	 * Acci que valida i guarda els canvis realitzats sobre un usuari. 
	 * @return AFEGIR, si l'acci s d'afegir. MODIFICAR, si l'acci es una actualitzaci. 
	 */
	public String guardarUsuari(){
		if(usuariActual.getDocument().equals("")){
			errorsComptaXM.add(getText("usuari.error.document"));
		}
		else{
			if(usuariModel.existeixDocument(usuariActual.getDocument(),idUsuariActual)){
				errorsComptaXM.add(getText("usuari.error.document.repetit"));
			}		
		}
		if(usuariActual.getNom().equals("")){
			errorsComptaXM.add(getText("usuari.error.nom"));
			
		}
		if(usuariActual.getLogin().equals("")){
			errorsComptaXM.add(getText("usuari.error.login"));			
		}else{
			if(usuariModel.existeixLogin(usuariActual.getLogin(),idUsuariActual)){
				errorsComptaXM.add(getText("usuari.error.login.repetit"));
			}
		}
		if(usuariActual.getPassword().equals("")){
			errorsComptaXM.add(getText("usuari.error.password"));
		}else{
			if(!usuariActual.getPassword().equals(this.rePassword)){
				errorsComptaXM.add(getText("usuari.error.password.noconcideix"));
			}
		}
		if(tipusUsuariActual==null){
			errorsComptaXM.add(getText("usuari.error.tipususuari"));
		}
		if(errorsComptaXM.size()==0){
			if(tipusUsuariActual.equals(getText("usuari.tipus.administrador"))){
				usuariActual.setTipusUsuari(usuariActual.getAdministrador());
			}else{
				usuariActual.setTipusUsuari(usuariActual.getCapPlanta());
			}
			if(tipusOperacio==1){
				usuariActual.setIdPersona(idUsuariActual);
				if(usuariModel.update(usuariActual)){
					addActionMessage(getText("usuari.text.inici")+" " +usuariActual.getLogin()+" "+getText("usuari.modificat.correctament"));
					return SUCCESS;
				}else{
						
					errorsComptaXM.add(getText("usuari.err.sql.update"));
					
				}
					
				 
			}else{				
				usuariActual.setEstat(1);
				if (usuariModel.add(usuariActual)){
					addActionMessage(getText("usuari.text.inici")+" " +usuariActual.getLogin()+" "+getText("usuari.afegit.correctament"));
					return SUCCESS;
				}else{
					errorsComptaXM.add(getText("usuari.err.sql.afegir"));					
				}				
			}						
		}
		session.put("errorsComptaXM", errorsComptaXM);
		errorsComptaXM= new ArrayList<String>();		
		if(tipusOperacio==1){
			return "modificar";
		}else{
			return "afegir";
		}
		
	}

	public int getOpcioMenu() {
		return opcioMenu;
	}

	public void setOpcioMenu(int opcioMenu) {
		this.opcioMenu = opcioMenu;
	}

	public String getTitol() {
		return titol;
	}

	public void setTitol(String titol) {
		this.titol = titol;
	}

}
