package uoc.tfc.xmartimo.action.connexio;


import java.util.Map; 
import org.apache.struts2.interceptor.SessionAware; 

import uoc.tfc.xmartimo.bean.connexio.Usuari;
import uoc.tfc.xmartimo.bean.connexio.UsuariHabilitat;
import uoc.tfc.xmartimo.model.connexio.UsuariModel;

import com.opensymphony.xwork2.ActionSupport;
/**
 * 
 * LoginAction. Accions que es realitzen per validar i connectar els usuaris<br>
 * al sistema
 * @author Xavier Mart Moret. TFC.J2EE
 *
 */
@SuppressWarnings("serial") 
public class loginAction extends ActionSupport implements SessionAware,UsuariHabilitat {

      private String identificador; 
      private String contrasena; 
      private String identificadorPredeterminado; 
      private String contrasenaPredeterminada; 
      private Map<String,Object> session;
      private UsuariModel usuariModel;
      private Usuari usuari;
      
    
	
	public loginAction(){
    	 usuariModel= new UsuariModel();
     }
      /** 
	 * @return the identificador
	 */
	public String getIdentificador() {
		return identificador;
	}

	/**
	 * @param identificador the identificador to set
	 */
	public void setIdentificador(String identificador) {
		this.identificador = identificador;
	}

	/**
	 * @return the contrasena
	 */
	public String getContrasena() {
		return contrasena;
	}

	/**
	 * @param contrasena the contrasena to set
	 */
	public void setContrasena(String contrasena) {
		this.contrasena = contrasena;
	}

	/**
	 * @return the identificadorPredeterminado
	 */
	public String getIdentificadorPredeterminado() {
		return identificadorPredeterminado;
	}

	/**
	 * @param identificadorPredeterminado the identificadorPredeterminado to set
	 */
	public void setIdentificadorPredeterminado(String identificadorPredeterminado) {
		this.identificadorPredeterminado = identificadorPredeterminado;
	}

	/**
	 * @return the contrasenaPredeterminada
	 */
	public String getContrasenaPredeterminada() {
		return contrasenaPredeterminada;
	}

	/**
	 * @param contrasenaPredeterminada the contrasenaPredeterminada to set
	 */
	public void setContrasenaPredeterminada(String contrasenaPredeterminada) {
		this.contrasenaPredeterminada = contrasenaPredeterminada;
	}

	/**
	 * @return the sessionMap
	 */
	public Map<String, Object> getSession() {
		return session;
	}

	/**
	 * @param sessionMap the sessionMap to set
	 */
	public void setSession(Map<String, Object> sessionMap) {
		this.session = sessionMap;
	}

	
      
	 /**
		 * @return the usuari
		 */
		public Usuari getUsuari() {
			return usuari;
		}
		/**
		 * @param usuari the usuari to set
		 */
		public void setUsuari(Usuari usuari) {
			this.usuari = usuari;
		}
      /**
       * Acci de connectar un usuari al Sistema
       * @return SUCCESS si la validaci es correcte, INPUT en cas d'error de validaci
       */

      public String connectar() {
             if(identificador!=null && contrasena!=null) 
             {                                	
            	 this.usuari=usuariModel.getUserByLogin(identificador);
            	 if(usuari instanceof Usuari){
            		 if (usuari.getPassword().equals(contrasena)){
            			 if(usuari.getEstat()==1){
            				 this.session.put("identificacio", true);  
            				 this.session.put("usuari", usuari);
                			 return SUCCESS;
            			 }else{
            				 addActionError(getText("login.error.baixa"));
            			 }            			             			 
            		 }
            	 }
            	 
              }
            addActionError(getText("login.error")); 
          
            return INPUT; 
    }
      /**
       * Acci que dona pas a l'usuari en el sistema
       * @return ADMIN, si l'usuari s un administrador. CAPPLANTA si l'usuari es un capPlanta 
       */
    public String entrar(){
    	if(usuari instanceof Usuari){ 
	    	if(usuari.getTipusUsuari().equals(usuari.getAdministrador())){
				 return "admin";
			 }else{
				 return "capPlanta";
			 }
    	}
    	return INPUT;
    }
    /**
     * Acci que desconnecta un usuari del sistema
     * @return SUCCESS, predeterminada.
     */
    public String desconnectar() { 
             // Tancar la sessio de l'usuari
             this.session.clear();

             return SUCCESS; 
     } 
}