package uoc.tfc.xmartimo.action.manteniment;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;

import org.apache.struts2.interceptor.SessionAware;

import uoc.tfc.xmartimo.bean.connexio.Usuari;
import uoc.tfc.xmartimo.bean.connexio.UsuariHabilitat;
import uoc.tfc.xmartimo.bean.manteniment.Centre;
import uoc.tfc.xmartimo.bean.manteniment.Compte;
import uoc.tfc.xmartimo.model.connexio.UsuariModel;
import uoc.tfc.xmartimo.model.manteniment.CentreModel;
import uoc.tfc.xmartimo.model.manteniment.CompteModel;

import com.opensymphony.xwork2.ActionSupport;

/**
 * CompteAction. Accions que fan referncia als comptes de resultats. <br>
 * Permet afegir, modificar i donar de baixa un compte.
 * @author Xavier Mart Moret. 
 *
 */
@SuppressWarnings("serial") 
public class CompteAction extends ActionSupport implements SessionAware,UsuariHabilitat {
	
	private List<String> errorsComptaXM= new ArrayList<String>();
	private List<Compte> comptes = new ArrayList<Compte>();
	private CompteModel compteModel;	
	private Usuari usuari;		
	private Compte compteActual;
	
	private int idCompteActual;
	
	private Map<String,Object> session;
	private int tipusOperacio;
	private String idFiltreCodi="";
	private String idFiltreDescripcio="";
	private int opcioMenu;
	private String titol;
	public CompteAction (){
			compteModel= new CompteModel();
			
	}
	public Usuari getUsuari() {
		return usuari;
	}
	public void setUsuari(Usuari usuari) {
		this.usuari = usuari;
	}
	
	/**
	 * @return the errorsComptaXM
	 */
	public List<String> getErrorsComptaXM() {
		return errorsComptaXM;
	}
	/**
	 * @param errorsComptaXM the errorsComptaXM to set
	 */
	public void setErrorsComptaXM(List<String> errorsComptaXM) {
		this.errorsComptaXM = errorsComptaXM;
	}
	
	/**
	 * @return the session
	 */
	public Map<String, Object> getSession() {
		return session;
	}
	/**
	 * @param session the session to set
	 */	
	public void setSession(Map<String, Object> session) {
		this.session = session;
	}

	public int getTipusOperacio() {
		return tipusOperacio;
	}
	public void setTipusOperacio(int tipusOperacio) {
		this.tipusOperacio = tipusOperacio;
	}
	/**
	 * @return the compteModel
	 */
	public CompteModel getCompteModel() {
		return compteModel;
	}
	/**
	 * @param compteModel the compteModel to set
	 */
	public void setCompteModel(CompteModel compteModel) {
		this.compteModel = compteModel;
	}
	/**
	 * @return the compteActual
	 */
	public Compte getCompteActual() {
		return compteActual;
	}
	/**
	 * @param compteActual the compteActual to set
	 */
	public void setCompteActual(Compte compteActual) {
		this.compteActual = compteActual;
	}
	/**
	 * @return the idCompteActual
	 */
	public int getIdCompteActual() {
		return idCompteActual;
	}
	/**
	 * @param idCompteActual the idCompteActual to set
	 */
	public void setIdCompteActual(int idCompteActual) {
		this.idCompteActual = idCompteActual;
	}
	/**
	 * @return the idFiltreCodi
	 */
	public String getIdFiltreCodi() {
		return idFiltreCodi;
	}
	/**
	 * @param idFiltreCodi the idFiltreCodi to set
	 */
	public void setIdFiltreCodi(String idFiltreCodi) {
		this.idFiltreCodi = idFiltreCodi;
	}
	/**
	 * @return the idFiltreDescripcio
	 */
	public String getIdFiltreDescripcio() {
		return idFiltreDescripcio;
	}
	/**
	 * @param idFiltreDescripcio the idFiltreDescripcio to set
	 */
	public void setIdFiltreDescripcio(String idFiltreDescripcio) {
		this.idFiltreDescripcio = idFiltreDescripcio;
	}
	public List<Compte> getComptes() {
		return comptes;
	}
	public void setComptes(List<Compte> comptes) {
		this.comptes = comptes;
	}
	/**
	 * Acci que obt els comptes existents en el sistema
	 * @return SUCCESS predeterminada.
	 */
	public String obtenirComptes(){
		titol=getText("compte.titol.index");
		setComptes(compteModel.obtenirComptes(idFiltreCodi,idFiltreDescripcio));		
		return SUCCESS;
	}
	/**
	 * Acci que afegeix un nou compte al sistema
	 * @return SUCCESS predeterminada.
	 */
	@SuppressWarnings("unchecked")
	public String afegirCompte(){		
		titol=getText("compte.titol.index");
		setErrorsComptaXM((List<String>) session.get("errorsComptaXM"));
		session.put("errorsComptaXM", new ArrayList<String>());	
		tipusOperacio=0;
		if(errorsComptaXM==null){			
			compteActual= new Compte();							
		}
		return SUCCESS;			
		
	}
	/**
	 * Acci que actualitza un compte en el sistema
	 * @return SUCCESS, predeterminat
	 */
	@SuppressWarnings("unchecked")
	public String modificarCompte(){
		titol=getText("compte.titol.index");
		setErrorsComptaXM((List<String>) session.get("errorsComptaXM"));
		session.put("errorsComptaXM", new ArrayList<String>());		
		tipusOperacio=1;
		if(errorsComptaXM!=null){
			if(errorsComptaXM.size()>0){
				return SUCCESS;
			}
		}
		compteActual= compteModel.obtenirCompte(idCompteActual);					
		return SUCCESS;
	}
	/**
	 * Acci que valida i guarda els canvis d'un compte 
	 * @return SUCCCESS si la validaci s correcte <br>
	 * AFEGIR si hi ha errors de validaci i l'acci s una inserci <br>
	 * MODIFICAR si hi ha errors de validaci i l'acci s una actualitzaci.
	 */
	public String guardarCompte(){
		if(compteActual.getCodi().equals("")){
			errorsComptaXM.add(getText("compte.error.codi"));
		}
		else{
			if(compteModel.existeixCompte(compteActual.getCodi(),compteActual.getIdCompte())){
				errorsComptaXM.add(getText("compte.error.codi.repetit"));
			}		
		}
		if(compteActual.getDescripcio().equals("")){
			errorsComptaXM.add(getText("compte.error.descripcio"));			
		}
						
		if(errorsComptaXM.size()==0){			
			if(tipusOperacio==1){
								
				if(compteModel.update(compteActual)){
					addActionMessage(getText("compte.text.inici")+" " +compteActual.getCodi()+" "+getText("compte.modificat.correctament"));
					return SUCCESS;
				}else{
					
					errorsComptaXM.add(getText("compte.err.sql.update"));					
				}								
			}else{				
				compteActual.setEstat(1);
				if (compteModel.add(compteActual)){
					addActionMessage(getText("compte.text.inici")+" " +compteActual.getCodi()+" "+getText("compte.afegit.correctament"));
					return SUCCESS;
				}else{
					errorsComptaXM.add(getText("compte.err.sql.afegir"));					
				}				
			}						
		}
		idCompteActual=compteActual.getIdCompte();
		session.put("errorsComptaXM", errorsComptaXM);
		errorsComptaXM= new ArrayList<String>();		
		if(tipusOperacio==1){
			return "modificar";
		}else{
			return "afegir";
		}
	}
	/**
	 * Acci que dona de baixa un compta actiu
	 * @return	SUCCESS predeterminat
	 */
	public String baixaCompte(){
		compteActual=compteModel.obtenirCompte(idCompteActual);
		session.put("modificarEstat", compteActual);
		session.put("accio", 0);		
		return SUCCESS;
	}
	/**
	 * Acci que dona d'alta un compte innactiu.
	 * @return SUCCESS predeterminat
	 */
	public String altaCompte(){
		compteActual=compteModel.obtenirCompte(idCompteActual);
		session.put("modificarEstat", compteActual);
		session.put("accio", 1);						
		return SUCCESS;
	}
	
	public int getOpcioMenu() {
		return opcioMenu;
	}
	public void setOpcioMenu(int opcioMenu) {
		this.opcioMenu = opcioMenu;
	}
	public String getTitol() {
		return titol;
	}
	public void setTitol(String titol) {
		this.titol = titol;
	}
	
}
