package uoc.tfc.xmartimo.action.manteniment;

import java.util.Map;

import org.apache.struts2.interceptor.SessionAware;

import com.opensymphony.xwork2.ActionSupport;

import uoc.tfc.xmartimo.bean.connexio.Usuari;
import uoc.tfc.xmartimo.bean.connexio.UsuariHabilitat;
import uoc.tfc.xmartimo.bean.manteniment.Centre;
import uoc.tfc.xmartimo.bean.manteniment.Compte;
import uoc.tfc.xmartimo.bean.manteniment.Proveidor;
import uoc.tfc.xmartimo.bean.rebut.Comanda;
import uoc.tfc.xmartimo.bean.rebut.Previsio;
import uoc.tfc.xmartimo.model.connexio.UsuariModel;


/**
 * Classe genrica. Serveix per Confirmar les accions d'activar, donar de baixa i eliminar <BR>
 * dels diferents objectes de l'aplicatiu 
 * @author Xavier Mart Moret UOC.TFC.J2EE
 *
 */
public class ConfirmaAction extends ActionSupport implements SessionAware,UsuariHabilitat {
	
	@SuppressWarnings("unused")
	private static final long serialVersionUID = 1L;
	private Map<String,Object> session;    
    private Usuari usuari;
	private String  missatge;
	private String titol;
	private boolean resultat;
	private int accio;
	private Object objecte;
	private String objecteToString;
	private UsuariModel usuariModel;
	public ConfirmaAction(){
		 
	}
	
	public Usuari getUsuari(){
		return this.usuari;
	}
	@Override
	public void setUsuari(Usuari usuari) {
		this.usuari=usuari;
		
	}
	  /**
		 * @return the session
		 */
		public Map<String, Object> getSession() {
			return session;
		}
	@Override
	public void setSession(Map<String, Object> arg0) {
		this.session=arg0;		
	}
	public String getMissatge() {
		return missatge;
	}
	public void setMissatge(String missatge) {
		this.missatge = missatge;
	}
	public String getTitol() {
		return titol;
	}
	public void setTitol(String titol) {
		this.titol = titol;
	}
	public boolean isResultat() {
		return resultat;
	}
	public void setResultat(boolean resultat) {
		this.resultat = resultat;
	}
	public int getAccio() {
		return accio;
	}
	public void setAccio(int accio) {
		this.accio = accio;
	}
	public Object getObjecte() {
		return objecte;
	}
	public void setObjecte(Object objecte) {
		this.objecte = objecte;
	}

	/**
	 * Acci d'entrada de la confirmaci. 
	 * @return
	 * ADMINISTRADOR, si l'usuari actiu es un administrador. <br>
	 * CAPPLANTA, si l'usuari actiu es un cap de planta
	 */
	public String obtenirConfirmacio(){
		objecte = session.get("modificarEstat");
		accio= (int) session.get("accio");
		objecteToString=" ... " + objecte.toString();
		if(objecte.getClass().equals(Usuari.class)){						 
			if(accio==0) {
				this.titol=getText("usuari.baixa.accio.confirma.titol");
				this.missatge=getText("usuari.baixa.accio.confirma.missatge");
				
			}else{
				this.titol=getText ("usuari.alta.accio.confirma.titol") ;
				this.missatge=getText("usuari.alta.accio.confirma.missatge");
			}
			
		}else if (objecte.getClass().equals(Previsio.class)){
			this.titol=getText("previsio.baixa.accio.confirma.titol");
			this.missatge=getText("previsio.baixa.accio.confirma.missatge"); 		
		}else if (objecte.getClass().equals(Comanda.class)){
			this.titol=getText("comanda.baixa.accio.confirma.titol");
			this.missatge=getText("comanda.baixa.accio.confirma.missatge"); 		
		}else if (objecte.getClass().equals(Centre.class)){
			if(accio==0){
				this.titol=getText("centre.baixa.accio.confirma.titol");
				this.missatge=getText("centre.baixa.accio.confirma.missatge");
			}else{
				this.titol=getText("centre.alta.accio.confirma.titol");
				this.missatge=getText("centre.alta.accio.confirma.missatge");
			}
			
		}else if (objecte.getClass().equals(Proveidor.class)){
			if(accio==0){
				this.titol=getText("proveidor.baixa.accio.confirma.titol");
				this.missatge=getText("proveidor.baixa.accio.confirma.missatge");
			}else{
				this.titol=getText("proveidor.alta.accio.confirma.titol");
				this.missatge=getText("proveidor.alta.accio.confirma.missatge");
			}
			
		}else if (objecte.getClass().equals(Compte.class)){
			if(accio==0){
				this.titol=getText("compte.baixa.accio.confirma.titol");
				this.missatge=getText("compte.baixa.accio.confirma.missatge");
			}else{
				this.titol=getText("compte.alta.accio.confirma.titol");
				this.missatge=getText("compte.alta.accio.confirma.missatge");
			}
			
		}
		if(usuari.getTipusUsuari().equals(usuari.getAdministrador())){
			return "administrador";			
		}else{
			return "capPlanta"; 
		}
	}
	/**
	 * Acci de sortida de la confirmaci.
	 * @return una sortida per cada tipus d'objecte <BR> 
	 * USUARI <BR>
	 * COMPTE <BR>
	 * CENTRE <BR>
	 * PERIODE <BR>
	 * PROVEIDOR <BR>
	 * PREVISIO <BR> 
	 * COMANDA 
	 */
	public String validarConfirmacio(){
		objecte = session.get("modificarEstat");
		accio= (int) session.get("accio");
		session.put("modificarEstat", null);
		session.put("accio", 1);
		if(objecte.getClass().equals(Usuari.class)){
			Usuari u= (Usuari)objecte;
			if(resultat){
				u.setEstat(accio);
				usuariModel=new UsuariModel();
				usuariModel.update(u);
				 
			}
			return "usuari";
		}else if(objecte.getClass().equals(Centre.class)){
			Centre u= (Centre)objecte;
			if(resultat){
				u.setEstat(accio);
				usuariModel=new UsuariModel();
				usuariModel.update(u);				 
			}
			return "centre";
		}else if(objecte.getClass().equals(Proveidor.class)){
			Proveidor u= (Proveidor)objecte;
			if(resultat){
				u.setEstat(accio);
				usuariModel=new UsuariModel();
				usuariModel.update(u);				 
			}
			return "proveidor";
		}else if(objecte.getClass().equals(Compte.class)){
			Compte u= (Compte)objecte;
			if(resultat){
				u.setEstat(accio);
				usuariModel=new UsuariModel();
				usuariModel.update(u);				 
			}
			return "compte";
		}else if (objecte.getClass().equals(Previsio.class)){
			Previsio u= (Previsio)objecte;
			
			if(resultat){				
				usuariModel=new UsuariModel();
				usuariModel.delete(u);				
			}
			return "previsio";
		}else if (objecte.getClass().equals(Comanda.class)){
			Comanda u= (Comanda)objecte;			
			if(resultat){				
				usuariModel=new UsuariModel();
				usuariModel.delete(u);				
			}
			return "comanda";
		}
		
		return "usuari"; 
	}
	public UsuariModel getUsuariModel() {
		return usuariModel;
	}
	public void setUsuariModel(UsuariModel usuariModel) {
		this.usuariModel = usuariModel;
	}

	public String getObjecteToString() {
		return objecteToString;
	}

	public void setObjecteToString(String objecteToString) {
		this.objecteToString = objecteToString;
	}

	

	
}
