package uoc.tfc.xmartimo.action.manteniment;

import java.text.DecimalFormat;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;

import org.apache.struts2.interceptor.SessionAware;

import uoc.tfc.xmartimo.bean.connexio.Usuari;
import uoc.tfc.xmartimo.bean.connexio.UsuariHabilitat;
import uoc.tfc.xmartimo.bean.manteniment.Centre;
import uoc.tfc.xmartimo.bean.manteniment.Compte;
import uoc.tfc.xmartimo.bean.manteniment.PeriodeComptableCompte;
import uoc.tfc.xmartimo.model.manteniment.CentreModel;
import uoc.tfc.xmartimo.model.manteniment.CompteModel;
import uoc.tfc.xmartimo.model.manteniment.PeriodeComptableModel;


import com.opensymphony.xwork2.ActionSupport;
/**
 * Classe que modela les accions per crear i mostrar l'informe per centres
 * @author Xavier Mart Moret UOC.TFC.J2EE
 *
 */
public class InformeCentreAction extends ActionSupport implements SessionAware,UsuariHabilitat {	
	private static final long serialVersionUID = 1L;
	private List<String> errorsComptaXM= new ArrayList<String>();
	private PeriodeComptableModel periodeComptableModel;	
	private List<PeriodeComptableCompte> periodesPerComptes = new ArrayList<PeriodeComptableCompte>(); 
	private List<Centre>centres = new ArrayList<Centre>();
	private List <Compte>comptes = new ArrayList<Compte>();	
	private List <Integer>filtreComptes= new ArrayList<Integer>();
	private Centre centreActual;
	private int idCentreActual;
	private CompteModel compteModel;
	private CentreModel centreModel;
	private String[][]dadesInforme;
	private Usuari usuari;		
	private Map<String,Object> session;	
	private int filtreAny;
	private List<Integer>anys= new ArrayList<Integer>();	
	private int opcioMenu;
	private String titol;
	private int semestre;
	
	private DecimalFormat df;
	private DecimalFormat df1; 
	
	private double[][]totalCentres;
	/**
	 * Constructor per defecte
	 */
	public InformeCentreAction(){
		periodeComptableModel=new PeriodeComptableModel(); 
		compteModel= new CompteModel();
		centreModel= new CentreModel();
		
		this.df=new DecimalFormat("#,##0.00 "+getText("label.moneda"));
		this.df1=new DecimalFormat("#,##0");
	}
		
	public List<String> getErrorsComptaXM() {
		return errorsComptaXM;
	}
	public void setErrorsComptaXM(List<String> errorsComptaXM) {
		this.errorsComptaXM = errorsComptaXM;
	}
	/**
	 * @return the periodeComptableModel
	 */
	public PeriodeComptableModel getPeriodeComptableModel() {
		return periodeComptableModel;
	}
	/**
	 * @param periodeComptableModel the periodeComptableModel to set
	 */
	public void setPeriodeComptableModel(PeriodeComptableModel periodeComptableModel) {
		this.periodeComptableModel = periodeComptableModel;
	}
	/**
	 * @return the usuari
	 */
	public Usuari getUsuari() {
		return usuari;
	}
	/**
	 * @param usuari the usuari to set
	 */
	public void setUsuari(Usuari usuari) {
		this.usuari = usuari;
	}
	/**
	 * @return the session
	 */
	public Map<String, Object> getSession() {
		return session;
	}
	/**
	 * @param session the session to set
	 */
	public void setSession(Map<String, Object> session) {
		this.session = session;
	}
	/**
	 * @return the opcioMenu
	 */
	public int getOpcioMenu() {
		return opcioMenu;
	}
	/**
	 * @param opcioMenu the opcioMenu to set
	 */
	public void setOpcioMenu(int opcioMenu) {
		this.opcioMenu = opcioMenu;
	}
	/**
	 * @return the titol
	 */
	public String getTitol() {
		return titol;
	}
	/**
	 * @param titol the titol to set
	 */
	public void setTitol(String titol) {
		this.titol = titol;
	}


	public int getFiltreAny() {
		return filtreAny;
	}


	public void setFiltreAny(int filtreAny) {
		this.filtreAny = filtreAny;
	}

	public List<PeriodeComptableCompte> getPeriodesPerComptes() {
		return periodesPerComptes;
	}

	public void setPeriodesPerComptes(List<PeriodeComptableCompte> periodesPerComptes) {
		this.periodesPerComptes = periodesPerComptes;
	}
	public List<Centre> getCentres() {
		return centres;
	}

	public void setCentres(List<Centre> centres) {
		this.centres = centres;
	}

	public List <Compte> getComptes() {
		return comptes;
	}

	public void setComptes(List <Compte> comptes) {
		this.comptes = comptes;
	}

	public CentreModel getCentreModel() {
		return centreModel;
	}

	public void setCentreModel(CentreModel centreModel) {
		this.centreModel = centreModel;
	}

	public CompteModel getCompteModel() {
		return compteModel;
	}

	public void setCompteModel(CompteModel compteModel) {
		this.compteModel = compteModel;
	}
	public String[][] getDadesInforme() {
		return dadesInforme;
	}

	public void setDadesInforme(String[][] dadesInforme) {
		this.dadesInforme = dadesInforme;
	}

	public List<Integer> getAnys() {
		return anys;
	}

	public void setAnys(List<Integer> anys) {
		this.anys = anys;
	}
	public List <Integer> getFiltreComptes() {
		return filtreComptes;
	}

	public void setFiltreComptes(List <Integer> filtreComptes) {
		this.filtreComptes = filtreComptes;
	}
	public Centre getCentreActual() {
		return centreActual;
	}

	public void setCentreActual(Centre centreActual) {
		this.centreActual = centreActual;
	}

	public int getIdCentreActual() {
		return idCentreActual;
	}

	public void setIdCentreActual(int idCentreActual) {
		this.idCentreActual = idCentreActual;
	}


	/**
	 * Acci per crea l'informe.<br> 
	 * Serveix per a presentar l'interfcie grfica per poder crear l'informe. 
	 * @return
	 * ADMINISTRADOR si l'usuari es un administrador <br>
	 * CAPPLANTA si l'usuari s un cap de planta <br>
	 */
	@SuppressWarnings("unchecked")
	public String crearInformeCentre(){
		this.titol=getText("informe.centre.titol");
		errorsComptaXM= (List<String>) session.get("errorsComptaXM");
		session.put("errorsComptaXM",new ArrayList<String>());					
		anys=periodeComptableModel.obtenirAnys();
		comptes=compteModel.obtenirComptes("", "");		
		if(usuari.getTipusUsuari().equals(usuari.getAdministrador())){
			centres=centreModel.obtenirCentres();
			return "administrador";
		}else{
			centres=centreModel.obtenirCentres(usuari.getIdPersona());
			return "capPlanta";
		}		
	}
	/**
	 * Acci que obt les dades de l'informe <br>
	 * A partir de les dades introdudes per l'usuari, obt les dades comptables del sistema 
	 * @return
	 * ADMINISTRADOR si no hi ha cap error, i l'usuari actiu es un administrador
	 * CAPPLANTA si no hi ha cap error, i l'usuari actiu s un cap de planta
	 * ERROR s'hi ha errors de validaci de dades, introdudes per l'usuari. 
	 */
	public String obtenirInformeCentre () {
		errorsComptaXM= new ArrayList<String>();
		this.titol=getText("informe.centre.titol");
		if(filtreAny<=0){
			errorsComptaXM.add(getText("informe.periode.error.any"));
		}
		if (idCentreActual<=0){
			errorsComptaXM.add(getText("informe.periode.error.centre"));
		}
		if (filtreComptes.size()==0){
			errorsComptaXM.add(getText("informe.periode.error.compte"));
		}		
		if(errorsComptaXM.size()==0){				
			int i =1;int j=1;
			periodesPerComptes=periodeComptableModel.obtenirComptesPerCentre(filtreAny, idCentreActual,semestre);						
			centreActual= centreModel.getCentreById(idCentreActual);
			for(Integer k:filtreComptes){
				comptes.add(compteModel.obtenirCompte(k));
			}
			
			dadesInforme= new String[comptes.size()+2][7];
			totalCentres= new double[7][2];
			j=1;
			if(semestre==1){
				for(i=1;i<=6;i++){
					dadesInforme[0][i]=getText("informe.mes"+i);				
				}	
			}else{
				for(i=7;i<=12;i++){
					dadesInforme[0][j]=getText("informe.mes"+i);
					j++;
				}
			}
			
			i=1;
			for(Compte c:comptes){
				dadesInforme[i][0]=c.getCodi();
				i++;
			}
			i=-1;
			j=-1;
			for(PeriodeComptableCompte pcc:periodesPerComptes){
				if (semestre==1) {
					j=pcc.getPeriodeComptable().getMes();
				}else{
					j=pcc.getPeriodeComptable().getMes()-6;
				}
				i=posCompte(pcc.getCompte());
				if(i>-1 && j>-1){
					
					StringBuilder builder = new StringBuilder();
					builder.append(df.format(pcc.getTotalComanda()));					
					builder.append("(" + (df1.format(pcc.getTotalComanda()-pcc.getTotalPrevisio()))+")");
					dadesInforme[i+1][j]=builder.toString();
					//dadesInforme[i+1][j]= df.format(pcc.getTotalComanda())+" (" + (df.format(pcc.getTotalComanda()-pcc.getTotalPrevisio()))+")";
					totalCentres[j][0]=totalCentres[j][0]+pcc.getTotalComanda();					 
					totalCentres[j][1]=totalCentres[j][1]+pcc.getTotalPrevisio();
				}
			}
			dadesInforme[comptes.size()+1][0]=getText("taula.total.compte.etiqueta");
			
			for(i=1;i<totalCentres.length;i++){
				dadesInforme[comptes.size()+1][i]= df.format(totalCentres[i][0])+ " (" +df1.format(totalCentres[i][0]-totalCentres[i][1])+")"; 
			}
			if(usuari.getTipusUsuari().equals(usuari.getAdministrador())){
				return "administrador";
			}else{
				return "capPlanta";
			}
		}		
		session.put("errorsComptaXM", errorsComptaXM);
		errorsComptaXM= new ArrayList<String>();
		return ERROR;
	}

	/**
	 * Cerca la posici d'un compte dins la llista de comtpes a presentar <br>
	 * Per cercar la fila de la taula a mostrar al client
	 * @param compte	Compte a cercar la posici
	 * @return int 	Posici del compte
	 */
	@SuppressWarnings("unused")
	private int posCompte(Compte compte){
		int i =0;
		for(Compte c:comptes){
			if (c.getIdCompte()==compte.getIdCompte()){
				return i;
			}
			i++;
		}
			
		return -1;	
	}
	/**
	 * Obt el semestre actual de l'informe
	 * @return SemestreActual
	 */
	public int getSemestre() {
		return semestre;
	}
	/**
	 * Guarda el semestra actual de l'informe
	 * @param semestre	Semestre actual
	 */
	public void setSemestre(int semestre) {
		this.semestre = semestre;
	}
	/**
	 * Obt les dades per centre de l'informe 
	 * @return double[][] dades globals de l'informe
	 */
	public double[][] getTotalCentres() {
		return totalCentres;
	}
	/**
	 * Guarda les dades per centre de l'informe.
	 * @param totalCentres Dades globals de l'informe.
	 */
	public void setTotalCentres(double[][] totalCentres) {
		this.totalCentres = totalCentres;
	}

	
	

}
