package uoc.tfc.xmartimo.action.manteniment;

import java.text.DecimalFormat;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;

import org.apache.struts2.interceptor.SessionAware;

import uoc.tfc.xmartimo.bean.connexio.Usuari;
import uoc.tfc.xmartimo.bean.connexio.UsuariHabilitat;
import uoc.tfc.xmartimo.bean.manteniment.Centre;
import uoc.tfc.xmartimo.bean.manteniment.Compte;
import uoc.tfc.xmartimo.bean.manteniment.PeriodeComptableCompte;
import uoc.tfc.xmartimo.model.manteniment.CentreModel;
import uoc.tfc.xmartimo.model.manteniment.CompteModel;
import uoc.tfc.xmartimo.model.manteniment.PeriodeComptableModel;


import com.opensymphony.xwork2.ActionSupport;
/**
 * Classe que modela les accions per crear i mostrar l'informe per perode comptable
 * @author Xavier Mart Moret UOC.TFC.J2EE
 *
 */
public class InformePeriodeAction extends ActionSupport implements SessionAware,UsuariHabilitat {	
	private static final long serialVersionUID = 1L;
	private List<String> errorsComptaXM= new ArrayList<String>();
	private PeriodeComptableModel periodeComptableModel;	
	private List<PeriodeComptableCompte> periodesPerComptes = new ArrayList<PeriodeComptableCompte>(); 
	private List<Centre>centres = new ArrayList<Centre>();
	private List <Compte>comptes = new ArrayList<Compte>();	
	private List <Integer>filtreComptes= new ArrayList<Integer>();
	private List <Integer>filtreCentres= new ArrayList<Integer>();
	private CompteModel compteModel;
	private CentreModel centreModel;
	private String[][]dadesInforme;
	private Usuari usuari;		
	private Map<String,Object> session;
	private int filtreMes;
	private int filtreAny;
	private List<Integer>mesos=new ArrayList<Integer>();
	private List<Integer>anys= new ArrayList<Integer>();	
	private int opcioMenu;
	private String titol;
	private DecimalFormat df;
	private DecimalFormat df1; 
	
	private double[][]totalCentres;	
	private static String novaLinia = System.getProperty("line.separator");
	/**
	 * Constructor per defecte
	 */
	public InformePeriodeAction(){
		periodeComptableModel=new PeriodeComptableModel(); 
		compteModel= new CompteModel();
		centreModel= new CentreModel();
		
		this.df=new DecimalFormat("#,##0.00 "+getText("label.moneda"));
		this.df1=new DecimalFormat("#,##0");
	}
		
	public List<String> getErrorsComptaXM() {
		return errorsComptaXM;
	}
	public void setErrorsComptaXM(List<String> errorsComptaXM) {
		this.errorsComptaXM = errorsComptaXM;
	}
	/**
	 * @return the periodeComptableModel
	 */
	public PeriodeComptableModel getPeriodeComptableModel() {
		return periodeComptableModel;
	}
	/**
	 * @param periodeComptableModel the periodeComptableModel to set
	 */
	public void setPeriodeComptableModel(PeriodeComptableModel periodeComptableModel) {
		this.periodeComptableModel = periodeComptableModel;
	}
	/**
	 * @return the usuari
	 */
	public Usuari getUsuari() {
		return usuari;
	}
	/**
	 * @param usuari the usuari to set
	 */
	public void setUsuari(Usuari usuari) {
		this.usuari = usuari;
	}
	/**
	 * @return the session
	 */
	public Map<String, Object> getSession() {
		return session;
	}
	/**
	 * @param session the session to set
	 */
	public void setSession(Map<String, Object> session) {
		this.session = session;
	}
	/**
	 * @return the opcioMenu
	 */
	public int getOpcioMenu() {
		return opcioMenu;
	}
	/**
	 * @param opcioMenu the opcioMenu to set
	 */
	public void setOpcioMenu(int opcioMenu) {
		this.opcioMenu = opcioMenu;
	}
	/**
	 * @return the titol
	 */
	public String getTitol() {
		return titol;
	}
	/**
	 * @param titol the titol to set
	 */
	public void setTitol(String titol) {
		this.titol = titol;
	}


	public int getFiltreMes() {
		return filtreMes;
	}


	public void setFiltreMes(int filtreMes) {
		this.filtreMes = filtreMes;
	}


	public int getFiltreAny() {
		return filtreAny;
	}


	public void setFiltreAny(int filtreAny) {
		this.filtreAny = filtreAny;
	}

	public List<PeriodeComptableCompte> getPeriodesPerComptes() {
		return periodesPerComptes;
	}

	public void setPeriodesPerComptes(List<PeriodeComptableCompte> periodesPerComptes) {
		this.periodesPerComptes = periodesPerComptes;
	}
	public List<Centre> getCentres() {
		return centres;
	}

	public void setCentres(List<Centre> centres) {
		this.centres = centres;
	}

	public List <Compte> getComptes() {
		return comptes;
	}

	public void setComptes(List <Compte> comptes) {
		this.comptes = comptes;
	}

	public CentreModel getCentreModel() {
		return centreModel;
	}

	public void setCentreModel(CentreModel centreModel) {
		this.centreModel = centreModel;
	}

	public CompteModel getCompteModel() {
		return compteModel;
	}

	public void setCompteModel(CompteModel compteModel) {
		this.compteModel = compteModel;
	}
	public String[][] getDadesInforme() {
		return dadesInforme;
	}

	public void setDadesInforme(String[][] dadesInforme) {
		this.dadesInforme = dadesInforme;
	}
	public List<Integer> getMesos() {
		return mesos;
	}

	public void setMesos(List<Integer> mesos) {
		this.mesos = mesos;
	}

	public List<Integer> getAnys() {
		return anys;
	}

	public void setAnys(List<Integer> anys) {
		this.anys = anys;
	}
	public List <Integer> getFiltreComptes() {
		return filtreComptes;
	}

	public void setFiltreComptes(List <Integer> filtreComptes) {
		this.filtreComptes = filtreComptes;
	}

	public List <Integer> getFiltreCentres() {
		return filtreCentres;
	}

	public void setFiltreCentres(List <Integer> filtreCentres) {
		this.filtreCentres = filtreCentres;
	}
	/**
	 * Acci per crea l'informe.<br> 
	 * Serveix per a presentar l'interfcie grfica per poder crear l'informe. 
	 * @return
	 * ADMINISTRADOR si l'usuari es un administrador <br>
	 * CAPPLANTA si l'usuari s un cap de planta <br>
	 */
	@SuppressWarnings("unchecked")
	public String crearInformePeriode(){
		this.titol=getText("informe.periode.titol");
		errorsComptaXM= (List<String>) session.get("errorsComptaXM");
		session.put("errorsComptaXM",new ArrayList<String>());
		for(int i = 1; i<= 12; i++)mesos.add(i);			
		anys=periodeComptableModel.obtenirAnys();
		comptes=compteModel.obtenirComptes("", "");
		
		if(usuari.getTipusUsuari().equals(usuari.getAdministrador())){
			centres=centreModel.obtenirCentres();
			return "administrador";
		}else{
			centres=centreModel.obtenirCentres(usuari.getIdPersona());
			return "capPlanta";
		}
		
	}
	/**
	 * Acci que obt les dades de l'informe <br>
	 * A partir de les dades introdudes per l'usuari, obt les dades comptables del sistema 
	 * @return
	 * ADMINISTRADOR si no hi ha cap error, i l'usuari actiu es un administrador
	 * CAPPLANTA si no hi ha cap error, i l'usuari actiu s un cap de planta
	 * ERROR s'hi ha errors de validaci de dades, introdudes per l'usuari. 
	 */
	public String obtenirInformePeriode () {
		this.titol=getText("informe.periode.titol");
		errorsComptaXM= new ArrayList<String>();
		if(filtreMes<=0){
			errorsComptaXM.add(getText("informe.periode.error.mes"));
		}
		if(filtreAny<=0){
			errorsComptaXM.add(getText("informe.periode.error.any"));
		}
		if (filtreCentres.size()==0){
			errorsComptaXM.add(getText("informe.periode.error.centre"));
		}
		if (filtreComptes.size()==0){
			errorsComptaXM.add(getText("informe.periode.error.compte"));
		}		
		if(errorsComptaXM.size()==0){				
			periodesPerComptes=periodeComptableModel.obtenirComptesPerPeriode(filtreAny, filtreMes);			
			for(Integer k:filtreCentres){
				centres.add(centreModel.getCentreById(k));
			}
			
			
			for(Integer k:filtreComptes){
				comptes.add(compteModel.obtenirCompte(k));
			}
			
			
			dadesInforme= new String[comptes.size()+2][centres.size()+1];
			
			totalCentres= new double[centres.size()+1][2];
			
			int i =1;
			for(Centre c:centres){
				dadesInforme[0][i]=c.getNom();
				i++;
			}	
			i=1;
			for(Compte c:comptes){
				dadesInforme[i][0]=c.getCodi();
				i++;
			}
			i=-1;
			int j=-1;
			for(PeriodeComptableCompte pcc:periodesPerComptes){
				j=posCentre(pcc.getPeriodeComptable().getCentre());
				i=posCompte(pcc.getCompte());
				if(i>-1 && j>-1){
					StringBuilder builder = new StringBuilder();
					builder.append(df.format(pcc.getTotalComanda()));
					builder.append(novaLinia);
					builder.append("(" + (df1.format(pcc.getTotalComanda()-pcc.getTotalPrevisio()))+")");
					dadesInforme[i+1][j+1]=builder.toString();
		
					 
					totalCentres[j+1][0]=totalCentres[j+1][0]+pcc.getTotalComanda();
					 
					totalCentres[j+1][1]=totalCentres[j+1][1]+pcc.getTotalPrevisio();
				}
			}
			
			dadesInforme[comptes.size()+1][0]=getText("taula.total.compte.etiqueta");
			
			for(i=1;i<totalCentres.length;i++){
				dadesInforme[comptes.size()+1][i]= df.format(totalCentres[i][0])+ " (" +df1.format(totalCentres[i][0]-totalCentres[i][1])+")"; 
			}
			
			if(usuari.getTipusUsuari().equals(usuari.getAdministrador())){
				return "administrador";
			}else{
				return "capPlanta";
			}
		}		
		session.put("errorsComptaXM", errorsComptaXM);
		errorsComptaXM= new ArrayList<String>();
		return ERROR;
	}
	/**
	 * Cerca la posici d'un centre dins la llista de centres a presentar <br>
	 * Per cercar la fila de la taula a mostrar al client
	 * @param compte	Compte a cercar la posici
	 * @return int 	Posici del centre
	 */
	@SuppressWarnings("unused")
	private int posCentre(Centre centre){
		int i =0;
		for(Centre c:centres){
			if (c.getIdPersona()==centre.getIdPersona()){
				return i;
			}
			i++;
		}
			
		return -1;	
	}
	/**
	 * Cerca la posici d'un compte dins la llista de comtpes a presentar <br>
	 * Per cercar la fila de la taula a mostrar al client
	 * @param compte	Compte a cercar la posici
	 * @return int 	Posici del compte
	 */
	@SuppressWarnings("unused")
	private int posCompte(Compte compte){
		int i =0;
		for(Compte c:comptes){
			if (c.getIdCompte()==compte.getIdCompte()){
				return i;
			}
			i++;
		}
			
		return -1;	
	}

	/**
	 * Obt les dades per centre de l'informe 
	 * @return double[][] dades globals de l'informe
	 */

	public double[][] getTotalCentres() {
		return totalCentres;
	}
	/**
	 * Guarda les dades per centre de l'informe.
	 * @param totalCentres Dades globals de l'informe.
	 */
	public void setTotalCentres(double[][] totalCentres) {
		this.totalCentres = totalCentres;
	}





	
	

}
