package uoc.tfc.xmartimo.action.manteniment;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;

import org.apache.struts2.interceptor.SessionAware;

import uoc.tfc.xmartimo.bean.connexio.Usuari;
import uoc.tfc.xmartimo.bean.connexio.UsuariHabilitat;

import uoc.tfc.xmartimo.bean.manteniment.Compte;
import uoc.tfc.xmartimo.bean.manteniment.PeriodeComptable;
import uoc.tfc.xmartimo.bean.manteniment.PeriodeComptableCompte;
import uoc.tfc.xmartimo.bean.manteniment.Proveidor;
import uoc.tfc.xmartimo.model.manteniment.CompteModel;
import uoc.tfc.xmartimo.model.manteniment.PeriodeComptableModel;
import uoc.tfc.xmartimo.model.manteniment.ProveidorModel;
import uoc.tfc.xmartimo.util.utilitats;

import com.opensymphony.xwork2.ActionSupport;
/**
 * Classe que modela les accions que fan referencia als periodes comptables agrupats per comptes
 * 
 * @author Xavier Mart Moret UOC.TFC.J2EE
 *
 */
public class PeriodeComptableCompteAction extends ActionSupport implements SessionAware,UsuariHabilitat{
	private static final long serialVersionUID = 1L;
	private Usuari usuari;
	private Map<String,Object> session;
	private List<PeriodeComptableCompte> periodePerComptes =new ArrayList<PeriodeComptableCompte>();
	private List<Compte>comptes =new ArrayList<Compte>();
	private PeriodeComptable periodeComptableActual;	
	private PeriodeComptableModel periodeModel;
	private CompteModel compteModel;
	private int idPeriodeActual; 	
	private String tipusRebut; 	
	private int opcioMenu;
	private String titol; 
	/**
	 * Constructor per defecte
	 */
	public PeriodeComptableCompteAction (){		
		this.setPeriodeModel(new PeriodeComptableModel());
		this.setCompteModel(new CompteModel());
			
	}
	public Usuari getUsuari(){
		return this.usuari;
	}
	public void setUsuari(Usuari usuari) {
		this.usuari=usuari;		
	}
	public Map<String, Object> getSession(){
		return this.session;
	}
	
	public void setSession(Map<String, Object> session) {
		this.session= session;
		
	}
	public List<PeriodeComptableCompte> getPeriodePerComptes() {
		return periodePerComptes;
	}
	public void setPeriodePerComptes(List<PeriodeComptableCompte> periodePerComptes) {
		this.periodePerComptes = periodePerComptes;
	}
		
	public int getIdPeriodeActual() {
		return idPeriodeActual;
	}
	public void setIdPeriodeActual(int idPeriodeActual) {
		this.idPeriodeActual = idPeriodeActual;
	}
	
	public PeriodeComptable getPeriodeComptableActual() {
		return periodeComptableActual;
	}
	public void setPeriodeComptableActual(PeriodeComptable periodeComptable) {
		this.periodeComptableActual = periodeComptable;
	}
	public PeriodeComptableModel getPeriodeModel() {
		return periodeModel;
	}
	public void setPeriodeModel(PeriodeComptableModel periodeModel) {
		this.periodeModel = periodeModel;
	}
	public List<Compte> getComptes() {
		return comptes;
	}
	public void setComptes(List<Compte> comptes) {
		this.comptes = comptes;
	}
	
	public CompteModel getCompteModel() {
		return compteModel;
	}
	public void setCompteModel(CompteModel compteModel) {
		this.compteModel = compteModel;
	}
	
	
	public String getTipusRebut() {
		return tipusRebut;
	}
	public void setTipusRebut(String tipusRebut) {
		this.tipusRebut = tipusRebut;
	}
	
	public int getOpcioMenu() {
		return opcioMenu;
	}
	public void setOpcioMenu(int opcioMenu) {
		this.opcioMenu = opcioMenu;
	}
	public String getTitol() {
		return titol;
	}
	public void setTitol(String titol) {
		this.titol = titol;
	}
	
	/**
	 * Acci que obt el periodeComptable seleccionat
	 * @return SUCCESS predeterminat.
	 */
	public String obtenirPeriodeComptableActual(){
		setTitol(getText("compte.periodeComptable.titol"));
		periodeComptableActual= periodeModel.obtenirPeriodeComptable(idPeriodeActual);	
		periodeComptableActual.setMesString(getText("informe.mes"+periodeComptableActual.getMes()));
		session.put("periodeComptableActual", periodeComptableActual);
		return SUCCESS;
	}
	
	/**
	 *  Acci que Retorna els resultats de tots els comptes que formen part d'un periodeComptable.
	 *  Ha de retornar tots els Comptes actius o no del periode Comptable
	 * @return
	 */
	@SuppressWarnings("unchecked")
	public String obtenirComptesPeriodeComptable(){	
		setTitol(getText("compte.periodeComptable.titol"));
		periodeComptableActual=(PeriodeComptable)session.get("periodeComptableActual");		
		periodePerComptes=periodeModel.obtenirComptesPerPeriode(periodeComptableActual.getIdPeriodeComptable());
		
		if(periodePerComptes!=null){
			for(PeriodeComptableCompte pcc:periodePerComptes){
				pcc.setCompte(compteModel.obtenirCompte(pcc.getCompte().getIdCompte()));
			}
		}		
		if (usuari.getTipusUsuari().equals(usuari.getAdministrador())){			
			
			return "administrador";
		}		
		else{
			
			return "capPlanta";
		}
					
	}

}
