package uoc.tfc.xmartimo.action.manteniment;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;

import org.apache.struts2.interceptor.SessionAware;

import uoc.tfc.xmartimo.bean.connexio.Persona;
import uoc.tfc.xmartimo.bean.connexio.Usuari;
import uoc.tfc.xmartimo.bean.connexio.UsuariHabilitat;
import uoc.tfc.xmartimo.bean.manteniment.Centre;
import uoc.tfc.xmartimo.bean.manteniment.Proveidor;
import uoc.tfc.xmartimo.model.connexio.UsuariModel;
import uoc.tfc.xmartimo.model.manteniment.CentreModel;
import uoc.tfc.xmartimo.model.manteniment.ProveidorModel;

import com.opensymphony.xwork2.ActionSupport;
/**
 * Acci que modela les accions del proveidor.
 * 
 * @author Xavier Mart Moret UOC.TFC.J2EE
 *
 */
@SuppressWarnings("serial") 
public class ProveidorAction extends ActionSupport implements SessionAware,UsuariHabilitat {
	
	private List<String> errorsComptaXM= new ArrayList<String>();
	private List<Proveidor> proveidors = new ArrayList<Proveidor>();
	private ProveidorModel proveidorModel;
	private CentreModel centreModel;
	private UsuariModel usuariModel;
	private Usuari usuari;		
	private List<Centre>centresUsuari= new ArrayList<Centre>();
	private List<Integer>nousProveidorsPerCentre= new ArrayList<Integer>();
	private Proveidor proveidorActual;
	private int idProveidorActual;
	private int idCentreActual;
	private Map<String,Object> session;
	private int tipusOperacio;
	private int opcioMenu;
	private String titol;
	private String idFiltreNom="";
	
	/**
	 * Constructor predeterminat
	 */
	public ProveidorAction (){
			this.centreModel= new CentreModel();
			this.proveidorModel= new ProveidorModel();
			this.usuariModel = new UsuariModel();
			
	}
		
	public Usuari getUsuari() {
		return usuari;
	}
	public void setUsuari(Usuari usuari) {
		this.usuari = usuari;
	}
	public int getIdCentreActual() {
		return idCentreActual;
	}
	public void setIdCentreActual(int idCentreActual) {
		this.idCentreActual = idCentreActual;
	}

	/**
	 * @return the errorsComptaXM
	 */
	public List<String> getErrorsComptaXM() {
		return errorsComptaXM;
	}
	/**
	 * @param errorsComptaXM the errorsComptaXM to set
	 */
	public void setErrorsComptaXM(List<String> errorsComptaXM) {
		this.errorsComptaXM = errorsComptaXM;
	}

	
	/**
	 * @return the session
	 */
	public Map<String, Object> getSession() {
		return session;
	}
	/**
	 * @param session the session to set
	 */
	public void setSession(Map<String, Object> session) {
		this.session = session;
	}
	
	public int getTipusOperacio() {
		return tipusOperacio;
	}
	public void setTipusOperacio(int tipusOperacio) {
		this.tipusOperacio = tipusOperacio;
	}
	public int getOpcioMenu() {
		return opcioMenu;
	}
	public void setOpcioMenu(int opcioMenu) {
		this.opcioMenu = opcioMenu;
	}
	public String getTitol() {
		return titol;
	}
	public void setTitol(String titol) {
		this.titol = titol;
	}
	public List<Proveidor> getProveidors() {
		return proveidors;
	}
	public void setProveidors(List<Proveidor> proveidors) {
		this.proveidors = proveidors;
	}
	public ProveidorModel getProveidorModel() {
		return proveidorModel;
	}
	public void setProveidorModel(ProveidorModel proveidorModel) {
		this.proveidorModel = proveidorModel;
	}

	/**
	 * @return the centreModel
	 */
	public CentreModel getCentreModel() {
		return centreModel;
	}

	/**
	 * @param centreModel the centreModel to set
	 */
	public void setCentreModel(CentreModel centreModel) {
		this.centreModel = centreModel;
	}

	public List<Centre> getCentresUsuari() {
		return centresUsuari;
	}

	public void setCentresUsuari(List<Centre> centresUsuari) {
		this.centresUsuari = centresUsuari;
	}

	public int getIdProveidorActual() {
		return idProveidorActual;
	}

	public void setIdProveidorActual(int idProveidorActual) {
		this.idProveidorActual = idProveidorActual;
	}
	public Proveidor getProveidorActual() {
		return proveidorActual;
	}

	public void setProveidorActual(Proveidor proveidorActual) {
		this.proveidorActual = proveidorActual;
	}
	public String getIdFiltreNom() {
		return idFiltreNom;
	}

	public void setIdFiltreNom(String idFiltreNom) {
		this.idFiltreNom = idFiltreNom;
	}
	/**
	 * Acci que obt els provedors existents en el sistema
	 * @return ADMINISTRADOR, si l'usuari actiu es un administrador <br>
	 * CAPPLANTA	si l'usuari actiu es un cap de planta
	 */
	public String obtenirProveidors(){		
		this.titol=getText("proveidor.titol.index");
		if(usuari.getTipusUsuari().equals(usuari.getAdministrador())){
			proveidors=proveidorModel.obtenirProveidors(idFiltreNom,idCentreActual);
			centresUsuari=centreModel.obtenirCentres();
			return "administrador";
		}else{			
			proveidors=proveidorModel.obtenirProveidorsCapPlanta(idFiltreNom,idCentreActual,usuari.getIdPersona());
			centresUsuari=centreModel.obtenirCentres(usuari.getIdPersona());
			return "capPlanta";
		}
						
	}
	/**
	 * Acci que afegeix un nou provedor al sistema
	 * 
	 * @return ADMINISTRADOR, si l'usuari actiu es un administrador <br>
	 * CAPPLANTA	si l'usuari actiu es un cap de planta
	 */
	@SuppressWarnings("unchecked")
	public String afegirProveidor(){		
		this.titol=getText("proveidor.titol.index");
		setErrorsComptaXM((List<String>) session.get("errorsComptaXM"));
		session.put("errorsComptaXM", new ArrayList<String>());
		//primer ens cal carregar els usuaris capPlanta.
		
		
		tipusOperacio=0;
		if(errorsComptaXM==null){
			setIdProveidorActual(-1);
			setProveidorActual(new Proveidor());
			
		}
		
		if(usuari.getTipusUsuari().equals(usuari.getAdministrador())){
			centresUsuari=centreModel.obtenirCentres();
			return "administrador";
		}else{
			centresUsuari=centreModel.obtenirCentres(usuari.getIdPersona());
			return "capPlanta";
		}
		
	}
	
	/**
	 * Acci que actualitza un proveidor existent en el sistema
	 * @return ADMINISTRADOR, si l'usuari actiu es un administrador <br>
	 * CAPPLANTA	si l'usuari actiu es un cap de planta
	 */
	@SuppressWarnings("unchecked")
	public String modificarProveidor(){
		this.titol=getText("proveidor.titol.index");
		setErrorsComptaXM((List<String>) session.get("errorsComptaXM"));
		session.put("errorsComptaXM", new ArrayList<String>());		
		tipusOperacio=1;
		
		if(errorsComptaXM==null){
			proveidorActual= proveidorModel.obtenirProveidor(idProveidorActual);
			idCentreActual= proveidorActual.getCentre().getIdPersona();
		}else{
			if(errorsComptaXM.size()==0){
				proveidorActual= proveidorModel.obtenirProveidor(idProveidorActual);
				idCentreActual= proveidorActual.getCentre().getIdPersona();
			}			
		}
					
		
		if(usuari.getTipusUsuari().equals(usuari.getAdministrador())){
			centresUsuari=centreModel.obtenirCentres();
			return "administrador";
		}else{
			centresUsuari=centreModel.obtenirCentres(usuari.getIdPersona());
			return "capPlanta";
		}
	}
	/**
	 * Acci que guarda un provedor en el sistema
	 * 
	 * @return SUCCESS acci predeterminada <br>
	 * AFEGIR s'hi ha errors de validaci i s una inserci.<br>
	 * MODIFICAR s'hi ha errors de validaci i es una actualtizaci.
	 */
	public String guardarProveidor(){
		
		if(proveidorActual.getDocument().equals("")){
			errorsComptaXM.add(getText("proveidor.error.document"));
		}
		
		if(proveidorActual.getNom().equals("")){
			errorsComptaXM.add(getText("proveidor.error.nom"));
			
		}				
		if(proveidorActual.getCentre().getIdPersona()<=0 && nousProveidorsPerCentre.size()==0){
			errorsComptaXM.add(getText("proveidor.error.centre"));
		}
		
		if(!proveidorActual.getDocument().equals("")&& proveidorActual.getCentre().getIdPersona()>0){
			if(proveidorModel.existeixProveidor(proveidorActual.getDocument(),idProveidorActual,proveidorActual.getCentre().getIdPersona())){
				errorsComptaXM.add(getText("proveidor.error.document.repetit"));
			}
		}
		if(!proveidorActual.getDocument().equals("")&& nousProveidorsPerCentre.size()>0){			
			for(int i:nousProveidorsPerCentre){				
				if(proveidorModel.existeixProveidor(proveidorActual.getDocument(),idProveidorActual,i)){
					errorsComptaXM.add( "( doc:" + proveidorActual.getDocument()+ " - "+centreModel.getCentreById(i).getNom()+"). "+ getText("proveidor.error.document.repetit"));
				}
			}
		}
		if(errorsComptaXM.size()==0){
			
			if(tipusOperacio==1){
				proveidorActual.setIdProveidor(idProveidorActual);
				proveidorActual.setCentre(centreModel.getCentreById(proveidorActual.getCentre().getIdPersona()));
				if(proveidorModel.update(proveidorActual)){
					addActionMessage(getText("proveidor.text.inici")+" " +proveidorActual.getDocument()+": "+proveidorActual.getNom()+" ("+proveidorActual.getCentre().getNom()+") "+getText("proveidor.modificat.correctament"));
					return SUCCESS;
				}else{						
					errorsComptaXM.add(getText("proveidor.err.sql.update"));					
				}								
			}else{
			
				for(Integer i:nousProveidorsPerCentre){
					proveidorActual.setCentre(centreModel.getCentreById(i));
						
					proveidorActual.setEstat(1);
					
					if (proveidorModel.add(proveidorActual)){
						addActionMessage(getText("proveidor.text.inici")+" " +proveidorActual.getDocument()+": "+proveidorActual.getNom()+" ("+proveidorActual.getCentre().getNom()+") "+getText("proveidor.afegit.correctament"));						
					}else{
						errorsComptaXM.add(getText("proveidor.err.sql.afegir"));					
					}
				}
				if(errorsComptaXM.size()==0){
					return SUCCESS;
				}
				
			}						
		}
		session.put("errorsComptaXM", errorsComptaXM);
		errorsComptaXM= new ArrayList<String>();		
		if(tipusOperacio==1){
			return "modificar";
		}else{
			return "afegir";
		}
	}
	/**
	 * Acci que dona de baixa un provedor actiu
	 * @return SUCCESS predeterminat
	 */
	public String baixaProveidor(){
		proveidorActual=proveidorModel.obtenirProveidor(idProveidorActual);
		session.put("modificarEstat", proveidorActual);
		session.put("accio", 0);		
		return SUCCESS;
	}
	/**
	 * 	Acci que activa un provedor donat de baixa
	 * @return SUCCESS	predeterminat
	 */
	public String altaProveidor(){
		proveidorActual=proveidorModel.obtenirProveidor(idProveidorActual);
		session.put("modificarEstat", proveidorActual);
		session.put("accio", 1);				
		
		return SUCCESS;
	}

	public List<Integer> getNousProveidorsPerCentre() {
		return nousProveidorsPerCentre;
	}

	public void setNousProveidorsPerCentre(List<Integer> nousProveidorsPerCentre) {
		this.nousProveidorsPerCentre = nousProveidorsPerCentre;
	}

	public UsuariModel getUsuariModel() {
		return usuariModel;
	}

	public void setUsuariModel(UsuariModel usuariModel) {
		this.usuariModel = usuariModel;
	}
	
}
