package uoc.tfc.xmartimo.action.manteniment;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;

import org.apache.struts2.interceptor.SessionAware;

import uoc.tfc.xmartimo.bean.connexio.Usuari;
import uoc.tfc.xmartimo.bean.connexio.UsuariHabilitat;
import uoc.tfc.xmartimo.bean.manteniment.Centre;
import uoc.tfc.xmartimo.model.connexio.UsuariModel;
import uoc.tfc.xmartimo.model.manteniment.CentreModel;

import com.opensymphony.xwork2.ActionSupport;
/**
 * centreAction. Accions que fan referncia als centres<br>
 * Permet afegir, modificar, donar de baixa els centres.
 * @author Xavier Mart Moret TFC.J2EE.
 */
@SuppressWarnings("serial") 
public class centreAction extends ActionSupport implements SessionAware,UsuariHabilitat {
	
	private List<String> errorsComptaXM= new ArrayList<String>();
	private List<Centre> centres = new ArrayList<Centre>();
	private CentreModel centreModel;
	private UsuariModel usuariModel;
	private Usuari usuari;
	private List<Usuari>usuarisCap= new ArrayList<Usuari>();
	private int idUsuariCentre;
	private Centre centreActual;
	private int idCentreActual;
	private Map<String,Object> session;
	private int tipusOperacio;
	private int opcioMenu;
	private String titol;
	public centreAction (){
			centreModel= new CentreModel();
			usuariModel= new UsuariModel();
		
			
	}
	public List<Centre> getCentres() {
		return centres;
	}
	public void setCentres(List<Centre> centres) {
		this.centres = centres;
	}
	public CentreModel getCentreModel() {
		return centreModel;
	}
	public void setCentreModel(CentreModel centreModel) {
		this.centreModel = centreModel;
	}	
	public Usuari getUsuari() {
		return usuari;
	}
	public void setUsuari(Usuari usuari) {
		this.usuari = usuari;
	}
	public int getIdCentreActual() {
		return idCentreActual;
	}
	public void setIdCentreActual(int idCentreActual) {
		this.idCentreActual = idCentreActual;
	}
	public List<Usuari> getUsuarisCap() {
		return usuarisCap;
	}
	public void setUsuarisCap(List<Usuari> usuarisCap) {
		this.usuarisCap = usuarisCap;
	}
	public Centre getCentreActual() {
		return centreActual;
	}
	public void setCentreActual(Centre centreActual) {
		this.centreActual = centreActual;
	}
	public int getIdUsuariCentre() {
		return idUsuariCentre;
	}
	public void setIdUsuariCentre(int idUsuariCentre) {
		this.idUsuariCentre = idUsuariCentre;
	}
	public UsuariModel getUsuariModel() {
		return usuariModel;
	}
	public void setUsuariModel(UsuariModel usuariModel) {
		this.usuariModel = usuariModel;
	}

	/**
	 * @return the errorsComptaXM
	 */
	public List<String> getErrorsComptaXM() {
		return errorsComptaXM;
	}
	/**
	 * @param errorsComptaXM the errorsComptaXM to set
	 */
	public void setErrorsComptaXM(List<String> errorsComptaXM) {
		this.errorsComptaXM = errorsComptaXM;
	}

	
	/**
	 * @return the session
	 */
	public Map<String, Object> getSession() {
		return session;
	}
	/**
	 * @param session the session to set
	 */
	public void setSession(Map<String, Object> session) {
		this.session = session;
	}
	/**
	 * Acci que obt els centres existents del sistema
	 * @return SUCCESS, predeterminat
	 */
	public String obtenirCentres(){
		this.titol=getText("centre.titol.index");
		centres=centreModel.obtenirCentres();		
		return SUCCESS;
	}
	/**
	 * Acci que retorna els centres de l'usuari actiu. 	
	 * @return SUCCESS, predeterminat
	 */
	public String obtenirCentresUsuari(){
		this.titol=getText("centre.titol.index");
		centres=centreModel.obtenirCentres(usuari.getIdPersona());
		return SUCCESS; 
	}
	public int getTipusOperacio() {
		return tipusOperacio;
	}
	public void setTipusOperacio(int tipusOperacio) {
		this.tipusOperacio = tipusOperacio;
	}
	/**
	 * Acci que afegeix un nou centre en el sistema
	 * @return SUCCESS, predeterminat
	 */
	public String afegirCentre(){		
		this.titol=getText("centre.titol.index");
		setErrorsComptaXM((List<String>) session.get("errorsComptaXM"));
		session.put("errorsComptaXM", new ArrayList<String>());
		//primer ens cal carregar els usuaris capPlanta.
		usuarisCap=usuariModel.getUsuaris(usuari.getCapPlanta());
		//carregar un nou centre
		tipusOperacio=0;
		if(errorsComptaXM==null){
			idUsuariCentre=-1;
			centreActual= new Centre();							
		}
		return SUCCESS;
				
		
	}
	/**
	 * Acci que actualitza un centre del sistema
	 * @return SUCCESS, predeterminada.
	 */
	@SuppressWarnings("unchecked")
	public String modificarCentre(){
		this.titol=getText("centre.titol.index");
		setErrorsComptaXM((List<String>) session.get("errorsComptaXM"));
		session.put("errorsComptaXM", new ArrayList<String>());
		usuarisCap=usuariModel.getUsuaris(usuari.getCapPlanta());
		tipusOperacio=1;
		if(errorsComptaXM!=null){
			if(errorsComptaXM.size()>0){
				return SUCCESS;
			}
		}
		centreActual= centreModel.getCentreById(idCentreActual);			
		idUsuariCentre=centreActual.getUsuari().getIdPersona();
		return SUCCESS;
	}
	/**
	 * Acci que valida i guarda les dades d'un centre
	 * 
	 * @return SUCCESS si la validaci es correcte. AFEGIR s'hi ha errors de validaci i es tracta d'una inserci <br>
	 * MODIFICAR s'hi ha errors de validaci i es tracta d'una actualtizaci
	 */
	public String guardarCentre(){
		if(centreActual.getDocument().equals("")){
			errorsComptaXM.add(getText("centre.error.document"));
		}
		else{
			if(usuariModel.existeixDocument(centreActual.getDocument(),idCentreActual)){
				errorsComptaXM.add(getText("centre.error.document.repetit"));
			}		
		}
		if(centreActual.getNom().equals("")){
			errorsComptaXM.add(getText("centre.error.nom"));
			
		}else{
			if(usuariModel.existeixNom(centreActual.getNom(),idCentreActual)){
				errorsComptaXM.add(getText("centre.error.nom.repetit"));
			}
		}
				
		if(idUsuariCentre<=0){
			errorsComptaXM.add(getText("centre.error.usuari"));
		}
		if(errorsComptaXM.size()==0){
			centreActual.setUsuari(usuariModel.getUserById(idUsuariCentre));
			if(tipusOperacio==1){
				centreActual.setIdPersona(idCentreActual);				
				if(centreModel.update(centreActual)){
					addActionMessage(getText("centre.text.inici")+" " +centreActual.getNom()+" "+getText("centre.modificat.correctament"));
					return SUCCESS;
				}else{						
					errorsComptaXM.add(getText("centre.err.sql.update"));					
				}								
			}else{				
				centreActual.setEstat(1);
				if (centreModel.add(centreActual)){
					addActionMessage(getText("centre.text.inici")+" " +centreActual.getNom()+" "+getText("centre.afegit.correctament"));
					return SUCCESS;
				}else{
					errorsComptaXM.add(getText("centre.err.sql.afegir"));					
				}				
			}						
		}
		session.put("errorsComptaXM", errorsComptaXM);
		errorsComptaXM= new ArrayList<String>();		
		if(tipusOperacio==1){
			return "modificar";
		}else{
			return "afegir";
		}
	}
	/**
	 * Acci que dona de baixa un centre actiu 
	 * @return SUCCESS predeterminat
	 */
	public String baixaCentre(){
		centreActual=centreModel.getCentreById(idCentreActual);
		session.put("modificarEstat", centreActual);
		session.put("accio", 0);		
		return SUCCESS;
	}
	/**
	 * Acci que dona d'alta un centre innactiu.
	 * @return SUCCESS predeterminat
	 */
	public String altaCentre(){
		centreActual=centreModel.getCentreById(idCentreActual);
		session.put("modificarEstat", centreActual);
		session.put("accio", 1);				
		
		return SUCCESS;
	}
	public int getOpcioMenu() {
		return opcioMenu;
	}
	public void setOpcioMenu(int opcioMenu) {
		this.opcioMenu = opcioMenu;
	}
	public String getTitol() {
		return titol;
	}
	public void setTitol(String titol) {
		this.titol = titol;
	}
}
