package uoc.tfc.xmartimo.action.manteniment;

import java.util.ArrayList;
import java.util.Calendar;
import java.util.Date;
import java.util.List;
import java.util.Map;

import org.apache.struts2.interceptor.SessionAware;

import uoc.tfc.xmartimo.bean.connexio.Usuari;
import uoc.tfc.xmartimo.bean.connexio.UsuariHabilitat;
import uoc.tfc.xmartimo.bean.manteniment.Centre;
import uoc.tfc.xmartimo.bean.manteniment.PeriodeComptable;
import uoc.tfc.xmartimo.model.manteniment.CentreModel;
import uoc.tfc.xmartimo.model.manteniment.PeriodeComptableModel;

import com.opensymphony.xwork2.ActionSupport;
/**
 * Classe que modela les accions realitzades sobre els perodes comptables <br>
 * Per crear nous periodes, activar-los, tancar-los i presentar-los
 * @author Xavier Mart Moret UOC.TFC.J2EE
 *
 */
public class periodeComptableAction extends ActionSupport implements SessionAware,UsuariHabilitat{
	
	private static final long serialVersionUID = 1L;
	private List<PeriodeComptable>periodesComptables=new ArrayList<PeriodeComptable>();
	private List <PeriodeComptable>nousPeriodesComptables=new ArrayList<PeriodeComptable>();
	private List<String> errorsComptaXM= new ArrayList<String>();
	private PeriodeComptableModel periodeComptableModel;
	private CentreModel centreModel; 
	private List<Integer> periodes;
	private Map<String,Object> session;
	private Usuari usuari;
	private List<Integer>llistaMesos =new ArrayList<Integer>();
	private int idMes;
	private List<Integer>llistaAnys= new ArrayList<Integer>();
	private int idAnyo;
	private List<Centre>llistaCentres= new ArrayList<Centre>();
	private int idCentreActual;
	private int opcioMenu;
	private String titol;
	/**
	 * Constructor per defecte
	 */
	public periodeComptableAction(){
		setPeriodeComptableModel(new PeriodeComptableModel());
		this.setCentreModel(new CentreModel());
		
	}
	public List<PeriodeComptable> getPeriodesComptables() {
		return periodesComptables;
	}
	public void setPeriodesComptables(List<PeriodeComptable> periodesComptables) {
		this.periodesComptables = periodesComptables;
	}
	public PeriodeComptableModel getPeriodeComptableModel() {
		return periodeComptableModel;
	}
	public void setPeriodeComptableModel(PeriodeComptableModel periodeComptableModel) {
		this.periodeComptableModel = periodeComptableModel;
	}
	public Usuari getUsuari() {
		return usuari;
	}
	public void setUsuari(Usuari usuari) {
		this.usuari = usuari;
	}
	
	public Map<String, Object> getSession() {
		return session;
	}
	public void setSession(Map<String, Object> session) {
		this.session=session;
		
	}
	/**
	 * @return the centreModel
	 */
	public CentreModel getCentreModel() {
		return centreModel;
	}
	/**
	 * @param centreModel the centreModel to set
	 */
	public void setCentreModel(CentreModel centreModel) {
		this.centreModel = centreModel;
	}
	/**
	 * @return the llistaMesos
	 */
	public List<Integer> getLlistaMesos() {
		return llistaMesos;
	}
	/**
	 * @param llistaMesos the llistaMesos to set
	 */
	public void setLlistaMesos(List<Integer> llistaMesos) {
		this.llistaMesos = llistaMesos;
	}
	/**
	 * @return the llistaAnys
	 */
	public List<Integer> getLlistaAnys() {
		return llistaAnys;
	}
	/**
	 * @param llistaAnys the llistaAnys to set
	 */
	public void setLlistaAnys(List<Integer> llistaAnys) {
		this.llistaAnys = llistaAnys;
	}
	/**
	 * @return the llistaCentres
	 */
	public List<Centre> getLlistaCentres() {
		return llistaCentres;
	}
	/**
	 * @param llistaCentres the llistaCentres to set
	 */
	public void setLlistaCentres(List<Centre> llistaCentres) {
		this.llistaCentres = llistaCentres;
	}
	/**
	 * @return the idMes
	 */
	public int getIdMes() {
		return idMes;
	}
	/**
	 * @param idMes the idMes to set
	 */
	public void setIdMes(int idMes) {
		this.idMes = idMes;
	}
	/**
	 * @return the idAnyo
	 */
	public int getIdAnyo() {
		return idAnyo;
	}
	/**
	 * @param idAnyo the idAnyo to set
	 */
	public void setIdAnyo(int idAnyo) {
		this.idAnyo = idAnyo;
	}
	/**
	 * @return the idCentreActual
	 */
	public int getIdCentreActual() {
		return idCentreActual;
	}
	/**
	 * @param idCentreActual the idCentreActual to set
	 */
	public void setIdCentreActual(int idCentreActual) {
		this.idCentreActual = idCentreActual;
	}
	/**
	 * @return the errorsComptaXM
	 */
	public List<String> getErrorsComptaXM() {
		return errorsComptaXM;
	}
	/**
	 * @param errorsComptaXM the errorsComptaXM to set
	 */
	public void setErrorsComptaXM(List<String> errorsComptaXM) {
		this.errorsComptaXM = errorsComptaXM;
	}
	public List <PeriodeComptable> getNousPeriodesComptables() {
		return nousPeriodesComptables;
	}
	public void setNousPeriodesComptables(List <PeriodeComptable> nousPeriodesComptables) {
		this.nousPeriodesComptables = nousPeriodesComptables;
	}
	public List<Integer> getPeriodes() {
		return periodes;
	}
	public void setPeriodes(List<Integer> periodes) {
		this.periodes = periodes;
	}
	public int getOpcioMenu() {
		return opcioMenu;
	}
	public void setOpcioMenu(int opcioMenu) {
		this.opcioMenu = opcioMenu;
	}
	public String getTitol() {
		return titol;
	}
	public void setTitol(String titol) {
		this.titol = titol;
	}
	/**
	 * Acci que obt els periodes comptables actius costat administrador
	 * @return SUCCESS predeterminat
	 */
	public String obtenirPeriodesComptablesActiusAdm (){
		titol=getText("periode.actiu.titol.index");
		llistaMesos=new ArrayList<Integer>();
		for(int i=1; i<=12 ; i++){
			llistaMesos.add(i);
		}
		llistaAnys=periodeComptableModel.obtenirAnys();
		periodesComptables=periodeComptableModel.obtenirPeriodesComptables(idMes,idAnyo,idCentreActual,1);
		for(PeriodeComptable p:periodesComptables){
			p.setMesString(getText("informe.mes"+p.getMes()));
		}
		llistaCentres=centreModel.obtenirCentres();
		//periodesComptables=periodeComptableModel.obtenirPeriodesComptablesActius();
		return SUCCESS;
	}
	/**
	 * Acci que obt els perodes comptables actius costat capPlanta <br>
	 * 
	 * @return SUCCESS predeterminat
	 */
	public String obtenirPeriodesComptablesActiusCap (){
		
		titol=getText("periode.actiu.titol.index");
		//periodesComptables=periodeComptableModel.obtenirPeriodesComptablesActius(usuari.getIdPersona());
		llistaMesos=new ArrayList<Integer>();
		for(int i=1; i<=12 ; i++){
			llistaMesos.add(i);
		}
		llistaCentres=centreModel.obtenirCentres(usuari.getIdPersona());
		llistaAnys=periodeComptableModel.obtenirAnys();
		periodesComptables=periodeComptableModel.obtenirPeriodesComptables(idMes,idAnyo,idCentreActual,usuari.getIdPersona(),1);
		for(PeriodeComptable p:periodesComptables){
			p.setMesString(getText("informe.mes"+p.getMes()));
		}
		return SUCCESS;
	}
	/**
	 * Acci que presenta la interficie per filtrar els perodes comptables actius
	 * @return SUCCESS predeterminat
	 */
	@SuppressWarnings("deprecation")
	public String obrirCercarPeriodesComptablesActius (){
		//llistaMesos, llistaAnys,llistaCentres
		titol=getText("periode.titol.actius.index");
		llistaMesos=new ArrayList<Integer>();
		for(int i=1; i<=12 ; i++){
			llistaMesos.add(i);
		}
		Calendar c= Calendar.getInstance();
		llistaAnys=new ArrayList<Integer>();//queda pendent saber el max dels periodes comptables 
		for(int i=2011;i<=(c.get(Calendar.YEAR))+1;i++){
			llistaAnys.add(i);
		}
		llistaCentres=centreModel.obtenirCentres();
		return SUCCESS;
	}
	/**
	 * Acci que presenta la interficie per filtrar els periodes comptables tancats
	 * @return SUCCESS predeterminat
	 */
	public String obrirCercarPeriodesComptablesTancats(){
		//llistaMesos, llistaAnys,llistaCentres
		titol= getText("periode.titol.tancats.index");
				llistaMesos=new ArrayList<Integer>();
				for(int i=1; i<=12 ; i++){
					llistaMesos.add(i);
				}
				Calendar c= Calendar.getInstance();
				llistaAnys=new ArrayList<Integer>();//queda pendent saber el max dels periodes comptables 
				for(int i=2011;i<=(c.get(Calendar.YEAR))+1;i++){
					llistaAnys.add(i);
				}
				llistaCentres=centreModel.obtenirCentres();
				return SUCCESS;
	}
	/**
	 * Acci que filtre els periodes comptables actius
	 * @return SUCCESS predeterminat
	 */
	public String  filtrarPeriodesActius(){
		periodesComptables=periodeComptableModel.obtenirPeriodesComptables(idMes,idAnyo,idCentreActual,1);		
		for(PeriodeComptable p:periodesComptables){
			p.setMesString(getText("informe.mes"+p.getMes()));
		}
		return SUCCESS;
	}
	/**
	 * Acci que filtre els perodes comptables tancats
	 * @return SUCCESS predeterminat
	 */
	public String  filtrarPeriodesTancats(){
		periodesComptables=periodeComptableModel.obtenirPeriodesComptables(idMes,idAnyo,idCentreActual,0);		
		for(PeriodeComptable p:periodesComptables){
			p.setMesString(getText("informe.mes"+p.getMes()));
		}
		return SUCCESS;
	}
	/**
	 * Acci que tanca un perode comptable actiu
	 * @return SUCCESS acci predeterminada <br>
	 * INPUT si no hi ha perodes per tancar
	 */
	public String tancarPeriode(){
		int i =0;
		if(periodes!=null ){
			for (Integer pc:periodes){
				i=i+periodeComptableModel.updateEstat(pc,false);			
			}
			addActionMessage(getText("periodes.modificar.estat.tancat")+" " +i+" "+getText("periodes.etiqueta"));
			return INPUT;
		}
		return SUCCESS;
	}
	/**
	 * Acci que activa periodes comptables tancats.
	 * @return SUCCESS acci prederminada <br>
	 * INPUT si no hi ha periodes comptables per activar
	 */
	public String activarPeriode(){
		int i =0;
		if(periodes!=null ){
			for (Integer pc:periodes){
				i=i+periodeComptableModel.updateEstat(pc,true);			
			}
			addActionMessage(getText("periodes.modificar.estat.activat")+" " +i+" "+getText("periodes.etiqueta"));
			return INPUT;
		}
		return SUCCESS;
	}
	/**
	 * Acci que presenta la interficie per crear nous perodes comptables
	 * @return SUCCESS predeterminat
	 */
	public String obrirNousPeriodesComptables(){
		titol=getText("periode.titol.nou.index");
		llistaMesos=new ArrayList<Integer>();
		for(int i=1; i<=12 ; i++){
			llistaMesos.add(i);
		}
		Calendar c= Calendar.getInstance();
		
		llistaAnys=new ArrayList<Integer>();//queda pendent saber el max dels periodes comptables 
		for(int i=2011;i<=(c.get(Calendar.YEAR))+1;i++){
			llistaAnys.add(i);
		}
		llistaCentres=centreModel.obtenirCentresActius();
		return SUCCESS;
	}
	/**
	 * Acci que cerca els possibles nous perodes comptables candidats a ser creats
	 * @return SUCCESS predeterminat
	 */
	public String cercarNousPeriodes(){
		
		if(idMes<=0){
			errorsComptaXM.add(getText("periode.error.mes"));
		}
		if (idAnyo<=2010){
			errorsComptaXM.add(getText("periode.error.anyo"));
		}
		if (errorsComptaXM.size()==0){		
			periodesComptables=periodeComptableModel.obtenirPeriodesComptables(idMes,idAnyo,0,-1);
			llistaCentres=centreModel.obtenirCentresActius();
			PeriodeComptable pc= null;			
			for (Centre c:llistaCentres){
				pc=new PeriodeComptable(idAnyo,idMes,c,false);
				pc.setMesString(getText("informe.mes"+pc.getMes()));
				if(!existeixPeriodeComptable(pc)){
					nousPeriodesComptables.add(pc);
				}			
			}
		}
		session.put("errorsComptaXM", errorsComptaXM);
		errorsComptaXM= new ArrayList<String>();	
		return SUCCESS;		
	}
	/**
	 * Acci que crea nous perodes comptables 
	 * @return SUCCESS predeterminat
	 */
	public String crearNousPeriodes (){
		@SuppressWarnings("unused")
		int i =0;		
		Centre c=null;
			for(Integer p:periodes){
				c=new Centre();			
				c.setIdPersona(p);
				periodeComptableModel.add(new PeriodeComptable(idAnyo,idMes,c,false));
				i++;				
			}						
		
		if(i==1){
			addActionMessage(getText("periode.creat") + " "+ i +" "+getText("periode.creat.etiqueta"));
		}else if (i>1 ) {
			addActionMessage(getText("periode.creats") + " "+ i +" "+getText("periodes.etiqueta"));
		}
		
		return SUCCESS;
	}
	/**
	 * Acci que comprova si un periode comptable existeix
	 * @param pc periode comptable
	 * @return	CERT si existeix, FALS en cas contrari
	 */
	@SuppressWarnings("unused")
	private boolean existeixPeriodeComptable(PeriodeComptable pc){		
		for(PeriodeComptable c:periodesComptables){
			if(pc.getAnyo()==c.getAnyo()&&pc.getMes()==c.getMes()&& pc.getCentre().getIdPersona()==c.getCentre().getIdPersona()){
				return true;
			}
		}		
		return false;
	}
		
}
