package uoc.tfc.xmartimo.action.rebut;

import java.util.ArrayList;

import java.util.List;
import java.util.Map;

import javax.swing.JOptionPane;


import org.apache.struts2.interceptor.SessionAware;
import uoc.tfc.xmartimo.bean.connexio.Usuari;
import uoc.tfc.xmartimo.bean.connexio.UsuariHabilitat;
import uoc.tfc.xmartimo.bean.manteniment.Compte;
import uoc.tfc.xmartimo.bean.manteniment.PeriodeComptable;
import uoc.tfc.xmartimo.bean.manteniment.Proveidor;
import uoc.tfc.xmartimo.bean.rebut.Comanda;
import uoc.tfc.xmartimo.model.manteniment.CompteModel;
import uoc.tfc.xmartimo.model.manteniment.ProveidorModel;
import uoc.tfc.xmartimo.model.rebut.RebutModel;
import uoc.tfc.xmartimo.util.utilitats;

import com.opensymphony.xwork2.ActionSupport;

/**
 * Classe que modela totes les accions sobre la comanda <br>
 * Presentar, afegir, modificar i eliminar. 
 * @author Xavier Mart Moret UOC.TFC.J2EE
 *
 */
public class ComandaAction extends ActionSupport implements SessionAware,UsuariHabilitat {
	private static final long serialVersionUID = 1L;
	private Usuari usuari;	
	private Map<String,Object> session;
	private Comanda comandaActual= new Comanda() ;
	private String valorActual=null;
	private String descripcioActual=null;
	private List<Proveidor>proveidors= new ArrayList<Proveidor>();
	private List<Compte> comptes= new ArrayList<Compte>();
	private List<Integer> dies = new ArrayList<Integer>(); //llista de dies
	private List<String>errorsComptaXM = new ArrayList<String>();	
	private List<Comanda>comandesComptePeriode= new ArrayList<Comanda>();	
	
	private RebutModel rebutModel;		
	private ProveidorModel proveidorModel;
	private CompteModel compteModel;
	
	private int idProveidorActual;	 
	private int idCompteActual;
	private int idComandaActual; 
	private int tipusOperacio;
	private double totalComandesCompte;
	private int opcioMenu;
	private String titol;
	/**
	 * Constructor per defecte
	 */
	public ComandaAction(){
		this.setRebutModel(new RebutModel());
		this.setProveidorModel(new ProveidorModel());
		this.setCompteModel(new CompteModel());
		
	}
	
	public Usuari getUsuari(){
		return this.usuari; 
	}
	public void setUsuari(Usuari usuari) {
		this.usuari=usuari;		
	}
	/**
	 * @return the session
	 */
	public Map<String, Object> getSession() {
		return session;
	}
	
	public void setSession(Map<String, Object> session) {
		this.session=session;
		
	}

	public RebutModel getRebutModel() {
		return rebutModel;
	}

	public void setRebutModel(RebutModel rebutModel) {
		this.rebutModel = rebutModel;
	}

	public Comanda getComandaActual() {		
			return comandaActual;		
	}

	public void setComandaActual(Comanda comandaActual) {		
			this.comandaActual = comandaActual;		
	}
		

	public int getIdProveidorActual() {
		return idProveidorActual;
	}

	public void setIdProveidorActual(int idProveidor) {
		this.idProveidorActual = idProveidor;
	}

	public ProveidorModel getProveidorModel() {
		return proveidorModel;
	}

	public void setProveidorModel(ProveidorModel proveidorModel) {
		this.proveidorModel = proveidorModel;
	}
	public int getIdCompteActual() {
		return idCompteActual;
	}

	public void setIdCompteActual(int idCompteActual) {
		this.idCompteActual = idCompteActual;
	}
	/**
	 * @return the compteModel
	 */
	public CompteModel getCompteModel() {
		return compteModel;
	}

	/**
	 * @param compteModel the compteModel to set
	 */
	public void setCompteModel(CompteModel compteModel) {
		this.compteModel = compteModel;
	}


	public List<Proveidor> getProveidors() {
		return proveidors;
	}

	public void setProveidors(List<Proveidor> proveidors) {
		this.proveidors = proveidors;
	}

	public List<Integer> getDies() {
		return dies;
	}

	public void setDies(List<Integer> dies) {
		this.dies = dies;
	}
	/**
	 * @return the valorActual
	 */
	public String getValorActual() {
		return valorActual;
	}

	/**
	 * @param valorActual the valorActual to set
	 */
	public void setValorActual(String valorActual) {
		this.valorActual = valorActual;
	}

	/**
	 * @return the errors
	 */
	public List<String> getErrorsComptaXM() {
		return errorsComptaXM;
	}

	/**
	 * @param errors the errors to set
	 */
	public void setErrorsComptaXM(List<String> errors) {
		this.errorsComptaXM = errors;
	}
	public String getDescripcioActual() {
		return descripcioActual;
	}

	public void setDescripcioActual(String descripcioActual) {
		this.descripcioActual = descripcioActual;
	}
	public List<Compte> getComptes() {
		return comptes;
	}

	public void setComptes(List<Compte> comptes) {
		this.comptes = comptes;
	}
	
	public List<Comanda> getComandesComptePeriode() {
		return comandesComptePeriode;
	}

	public void setComandesComptePeriode(List<Comanda> comandesComptePeriode) {
		this.comandesComptePeriode = comandesComptePeriode;
	}
	public int getIdComandaActual() {
		return idComandaActual;
	}

	public void setIdComandaActual(int idComandaActual) {
		this.idComandaActual = idComandaActual;
	}
	public int getTipusOperacio() {
		return tipusOperacio;
	}

	public void setTipusOperacio(int tipusOperacio) {
		this.tipusOperacio = tipusOperacio;
	}
	public double getTotalComandesCompte() {
		return totalComandesCompte;
	}

	public void setTotalComandesCompte(double totalComandesCompte) {
		this.totalComandesCompte = totalComandesCompte;
	}
	/**
	 * Acci que afegeix o modifica una nova comanda al sistema
	 * @return  SUCCESS si es tracta d'una inserci <br>
	 * INPUT 	si es tracta d'una actualitzaci.<BR> 
	 * ERROR 	si hi ha errors de validaci. 
	 */
	public String afegirComanda(){		
		this.titol=getText("comanda.gestio.titol");
		if(comandaActual.getDia()==-1){
			errorsComptaXM.add(getText("rebut.error.dia"));
		}				
		if(idCompteActual==-1){
			errorsComptaXM.add(getText("rebut.error.compte"));
		}
		if(descripcioActual.equals("")){
			errorsComptaXM.add(getText("rebut.error.descripcio"));
		}
		if(!utilitats.isDouble(valorActual)){
			errorsComptaXM.add(getText("rebut.error.valor"));
		}
				
		if (errorsComptaXM.size()==0){
			if(tipusOperacio==1){
				comandaActual= rebutModel.obtenirComanda(idComandaActual);
			}
			comandaActual.setDescripcio(this.descripcioActual);
			comandaActual.setValor(Double.parseDouble(this.valorActual));
			comandaActual.setPeriodeComptable((PeriodeComptable)session.get("periodeComptableActual"));
			
			if(idProveidorActual>0){
				comandaActual.setProveidor(proveidorModel.obtenirProveidor(idProveidorActual));
			}
			
			comandaActual.setCompte(compteModel.obtenirCompte(idCompteActual));
			if(tipusOperacio==0){
				if(rebutModel.add(comandaActual)){
					addActionMessage(getText("comanda.text.inici")+" " +comandaActual.getDescripcio()+" "+getText("comanda.afegit.correctament"));
					return "success";
				}else{
					errorsComptaXM.add(getText("comanda.err.sql.afegir"));
				}
				
			}else{
				
				if(rebutModel.update(comandaActual)){
					addActionMessage(getText("comanda.text.inici")+" " +comandaActual.getDescripcio()+" "+getText("comanda.modificat.correctament"));
					comandaActual.setDescripcio("");
					comandaActual.setDia(-1);
					comandaActual.setValor(0.0);
					return "input";
				}else{
					errorsComptaXM.add(getText("comanda.err.sql.update"));
				}
				
			}			
		}
			
		
		session.put("errorsComptaXM", errorsComptaXM);
		errorsComptaXM= new ArrayList<String>();					
		return "error";			
		
	}
	/**
	 * Acci que presenta la interficie per poder afegir o modificar una comanda
	 * @return 	ADMINISTRADOR si l'usuari actiu es un administrador <br>
	 * CAPPLANTA	si l'usuari actiu es un cap de planta 
	 */
	@SuppressWarnings("unchecked")
	public String obrirAfegirComandaCompte(){
		this.titol=getText("comanda.gestio.titol");		
		errorsComptaXM=(List<String>) session.get("errorsComptaXM");
		session.put("errorsComptaXM", new ArrayList<String>());
		
		if(tipusOperacio==1){
			comandaActual= rebutModel.obtenirComanda(idComandaActual);
		}		
		comandaActual.setPeriodeComptable((PeriodeComptable)session.get("periodeComptableActual"));			
		this.comptes=compteModel.obtenirComptesActius();	
		this.dies=utilitats.obtenirDies(comandaActual.getPeriodeComptable().getMes(),comandaActual.getPeriodeComptable().getAnyo());
		proveidors=proveidorModel.obtenirProveidors(comandaActual.getPeriodeComptable().getCentre().getIdPersona());
		if (usuari.getTipusUsuari().equals(usuari.getAdministrador())){			
			return "administrador";
		}		
		else{
			
			return "capPlanta";
		}
	}

	/**
	 * Acci que presenta les comandes d'un compte seleccionat
	 * @return 	ADMINISTRADOR si l'usuari actiu es un administrador <br>
	 * CAPPLANTA	si l'usuari actiu es un cap de planta
	 */
	@SuppressWarnings("unchecked")
	public String presentarComandesCompte(){		
		this.titol=getText("comanda.gestio.titol");
		errorsComptaXM=(List<String>) session.get("errorsComptaXM");
		session.put("errorsComptaXM", new ArrayList<String>());
		comandaActual.setPeriodeComptable(((PeriodeComptable)session.get("periodeComptableActual")));
		comandaActual.setCompte(compteModel.obtenirCompte(idCompteActual));
		//comandaActual.setProveidor(proveidorModel.obtenirProveidor(comandaActual.getProveidor().getIdProveidor()));
		session.put("idCompteActual", idCompteActual);
		comandesComptePeriode= rebutModel.obtenirComandes(((PeriodeComptable) session.get("periodeComptableActual")).getIdPeriodeComptable(), idCompteActual);
		totalComandesCompte= rebutModel.obtenirTotalComandaCompte(comandaActual.getPeriodeComptable().getIdPeriodeComptable(),idCompteActual);
		this.dies=utilitats.obtenirDies(comandaActual.getPeriodeComptable().getMes(),comandaActual.getPeriodeComptable().getAnyo());
		proveidors=proveidorModel.obtenirProveidors(comandaActual.getPeriodeComptable().getCentre().getIdPersona());		
		
		/*
		if(proveidors!=null){
			for(Proveidor p:proveidors){
				p.setPersona(usuariModel)
			}
		}*/
		
		if (usuari.getTipusUsuari().equals(usuari.getAdministrador())){					
			return "administrador";
		}		
		else{			
			return "capPlanta";
		}
	}
	/**
	 * Acci que afegeix una comanda a un compte seleccionat
	 * @return 	SUCCESS predeterminat
	 * 
	 */
	public String afegirComandaCompte(){		
		if(comandaActual.getDia()==-1){
			errorsComptaXM.add(getText("rebut.error.dia"));
		}				
		if(idCompteActual==-1){
			errorsComptaXM.add(getText("rebut.error.compte"));
		}
		if(descripcioActual.equals("")){
			errorsComptaXM.add(getText("rebut.error.descripcio"));
		}
		if(!utilitats.isDouble(valorActual)){
			errorsComptaXM.add(getText("rebut.error.valor"));
		}
				
		if (errorsComptaXM.size()==0){
			comandaActual.setDescripcio(this.descripcioActual);
			comandaActual.setValor(Double.parseDouble(this.valorActual));
			comandaActual.setPeriodeComptable((PeriodeComptable)session.get("periodeComptableActual"));		
			comandaActual.setProveidor(proveidorModel.obtenirProveidor(idProveidorActual));			
			comandaActual.setCompte(compteModel.obtenirCompte(idCompteActual));
			if(rebutModel.add(comandaActual)){
				comandaActual.setDescripcio("");
				comandaActual.setDia(0);
				idProveidorActual=0;
				comandaActual.setValor(0.0);
				addActionMessage(getText("comanda.text.inici")+" " +comandaActual.getDescripcio()+" "+getText("comanda.modificat.correctament"));
			}else{
				errorsComptaXM.add(getText("comanda.err.sql.afegir"));
			}		
		}
		session.put("errorsComptaXM", errorsComptaXM);
		errorsComptaXM= new ArrayList<String>();					
						
		
		return SUCCESS;
	}
	/**
	 * Acci que elimina una comanda d'un compte que existeix en el sistema
	 * @return SUCCESS predeterminat
	 */
	public String eliminarComandaCompte(){							
		comandaActual= rebutModel.obtenirComanda(idComandaActual);	
		
		session.put("modificarEstat", comandaActual);
		session.put("accio", 0);		
		return SUCCESS;
	}
	/**
	 * Acci que refresca les comandes d'un compte seleccionat
	 *  
	 * @return ADMINISTRADOR si l'usuari actiu es un administrador <br>
	 * CAPPLANTA si l'uauari actiu es un cap de planta.
	 */
	@SuppressWarnings("unchecked")
	public String refrescarComandesCompte(){
		errorsComptaXM=(List<String>) session.get("errorsComptaXM");
		session.put("errorsComptaXM", new ArrayList<String>());
		this.idCompteActual= (int) session.get("idCompteActual");
		comandaActual.setProveidor(proveidorModel.obtenirProveidor(idProveidorActual));
		comandaActual.setPeriodeComptable(((PeriodeComptable)session.get("periodeComptableActual")));
		comandaActual.setCompte(compteModel.obtenirCompte(idCompteActual));
		comandesComptePeriode= rebutModel.obtenirComandes(((PeriodeComptable) session.get("periodeComptableActual")).getIdPeriodeComptable(), idCompteActual);
		totalComandesCompte= rebutModel.obtenirTotalComandaCompte(comandaActual.getPeriodeComptable().getIdPeriodeComptable(),idCompteActual);		
		if (usuari.getTipusUsuari().equals(usuari.getAdministrador())){				
			return "administrador";
		}		
		else{		
			return "capPlanta";
		}
	}

	public int getOpcioMenu() {
		return opcioMenu;
	}

	public void setOpcioMenu(int opcioMenu) {
		this.opcioMenu = opcioMenu;
	}

	public String getTitol() {
		return titol;
	}

	public void setTitol(String titol) {
		this.titol = titol;
	}
}
