package uoc.tfc.xmartimo.action.rebut;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import javax.swing.JOptionPane;

import org.apache.struts2.interceptor.SessionAware;
import uoc.tfc.xmartimo.bean.connexio.Usuari;
import uoc.tfc.xmartimo.bean.connexio.UsuariHabilitat;
import uoc.tfc.xmartimo.bean.manteniment.Compte;
import uoc.tfc.xmartimo.bean.manteniment.PeriodeComptable;


import uoc.tfc.xmartimo.bean.rebut.Previsio;

import uoc.tfc.xmartimo.model.manteniment.CompteModel;

import uoc.tfc.xmartimo.model.rebut.RebutModel;
import uoc.tfc.xmartimo.util.utilitats;

import com.opensymphony.xwork2.ActionSupport;

/**
 * Classe qu modela totes les accions que fan referncia a les previsions<br>
 * Presentar, afegir, modificar i eliminar.
 * 
 * @author Xavier Mart Moret UOC.TFC.J2EE
 *
 */
public class PrevisioAction extends ActionSupport implements SessionAware,UsuariHabilitat {
	private static final long serialVersionUID = 1L;
	private Usuari usuari;	
	private Map<String,Object> session;
	
	private Previsio previsioActual = new Previsio();	
		
	private String valorActual=null;
	private String descripcioActual=null;	
	private List<Compte> comptes= new ArrayList<Compte>();	
	private List<String>errorsComptaXM = new ArrayList<String>();
	
	private List<Previsio>previsionsComptePeriode= new ArrayList<Previsio>();
	
	
	private RebutModel rebutModel;			
	private CompteModel compteModel;	
	
	private int idCompteActual;
	
	private int idPrevisioActual; 
	private int tipusOperacio;
	private double totalPrevisionsCompte;
	private int opcioMenu;
	private String titol;
	/**
	 * Constructor per defecte
	 */
	public PrevisioAction(){
		this.setRebutModel(new RebutModel());		
		this.setCompteModel(new CompteModel());
		
	}
	
	public Usuari getUsuari(){
		return this.usuari; 
	}
	public void setUsuari(Usuari usuari) {
		this.usuari=usuari;		
	}
	/**
	 * @return the session
	 */
	public Map<String, Object> getSession() {
		return session;
	}
	
	public void setSession(Map<String, Object> session) {
		this.session=session;
		
	}

	public RebutModel getRebutModel() {
		return rebutModel;
	}

	public void setRebutModel(RebutModel rebutModel) {
		this.rebutModel = rebutModel;
	}

	public int getIdCompteActual() {
		return idCompteActual;
	}

	public void setIdCompteActual(int idCompteActual) {
		this.idCompteActual = idCompteActual;
	}
	/**
	 * @return the compteModel
	 */
	public CompteModel getCompteModel() {
		return compteModel;
	}

	/**
	 * @param compteModel the compteModel to set
	 */
	public void setCompteModel(CompteModel compteModel) {
		this.compteModel = compteModel;
	}
	/**
	 * @return the valorActual
	 */
	public String getValorActual() {
		return valorActual;
	}

	/**
	 * @param valorActual the valorActual to set
	 */
	public void setValorActual(String valorActual) {
		this.valorActual = valorActual;
		
	}

	/**
	 * @return the errors
	 */
	public List<String> getErrorsComptaXM() {
		return errorsComptaXM;
	}

	/**
	 * @param errors the errors to set
	 */
	public void setErrorsComptaXM(List<String> errors) {
		this.errorsComptaXM = errors;
	}
	public String getDescripcioActual() {
		return descripcioActual;
	}

	public void setDescripcioActual(String descripcioActual) {
		this.descripcioActual = descripcioActual;
	}
	public List<Compte> getComptes() {
		return comptes;
	}

	public void setComptes(List<Compte> comptes) {
		this.comptes = comptes;
	}
	public Previsio getPrevisioActual() {
		return previsioActual;
	}

	public void setPrevisioActual(Previsio previsioActual) {
		this.previsioActual = previsioActual;
	}
	public List<Previsio> getPrevisionsComptePeriode() {
		return previsionsComptePeriode;
	}

	public void setPrevisionsComptePeriode(List<Previsio> previsionsComptePeriode) {
		this.previsionsComptePeriode = previsionsComptePeriode;
	}

	
	/**
	 * @return the idPrevisioActual
	 */
	public int getIdPrevisioActual() {
		return idPrevisioActual;
	}

	/**
	 * @param idPrevisioActual the idPrevisioActual to set
	 */
	public void setIdPrevisioActual(int idPrevisioActual) {
		this.idPrevisioActual = idPrevisioActual;
	}

	/**
	 * @return the tipusOperacio
	 */
	public int getTipusOperacio() {
		return tipusOperacio;
	}

	/**
	 * @param tipusOperacio the tipusOperacio to set
	 */
	public void setTipusOperacio(int tipusOperacio) {
		this.tipusOperacio = tipusOperacio;
	}

	/**
	 * @return the totalPrevisionsCompte
	 */
	public double getTotalPrevisionsCompte() {
		return totalPrevisionsCompte;
	}

	/**
	 * @param totalPrevisionsCompte the totalPrevisionsCompte to set
	 */
	public void setTotalPrevisionsCompte(double totalPrevisionsCompte) {
		this.totalPrevisionsCompte = totalPrevisionsCompte;
	}
	/**
	 * Acci que afegeix o modifica una nova previsio al sistema
	 * @return  SUCCESS si es tracta d'una inserci <br>
	 * INPUT 	si es tracta d'una actualitzaci.<BR> 
	 * ERROR 	si hi ha errors de validaci. 
	 */
	public String afegirPrevisio(){
		this.titol=getText("previsio.gestio.titol");
		if(idCompteActual==-1){
			errorsComptaXM.add(getText("rebut.error.compte"));
		}
		if(descripcioActual.equals("")){
			errorsComptaXM.add(getText("rebut.error.descripcio"));
		}
		if(!utilitats.isDouble(valorActual)){
			errorsComptaXM.add(getText("rebut.error.valor"));
		}
				
		if (errorsComptaXM.size()==0){	
			
			if (tipusOperacio==1){
				previsioActual= rebutModel.obtenirPrevisio(idPrevisioActual);
			}
			previsioActual.setDescripcio(this.descripcioActual);
			previsioActual.setValor(Double.parseDouble(this.valorActual));
			previsioActual.setPeriodeComptable((PeriodeComptable)session.get("periodeComptableActual"));				
			previsioActual.setCompte(compteModel.obtenirCompte(idCompteActual));
			if (tipusOperacio==0){
				if(rebutModel.add(previsioActual)){
					addActionMessage(getText("previsio.text.inici")+" " +previsioActual.getDescripcio()+" "+getText("previsio.afegit.correctament"));
					return "success";
				}else{
					errorsComptaXM.add(getText("previsio.err.sql.afegir"));
				}
				
			}else{
				if(rebutModel.update(previsioActual)){
					addActionMessage(getText("previsio.text.inici")+" " +previsioActual.getDescripcio()+" "+getText("previsio.modificat.correctament"));
					previsioActual.setDescripcio("");				
					previsioActual.setValor(0.0);
					return "input";
				}else{
					errorsComptaXM.add(getText("previsio.err.sql.modificar"));
				}
							
			}
			
			
		}
		session.put("errorsComptaXM", errorsComptaXM);
		errorsComptaXM= new ArrayList<String>();		
		return "error";
	}
	/**
	 * Acci que presenta la interficie per poder afegir o modificar una previsio
	 * @return 	ADMINISTRADOR si l'usuari actiu es un administrador <br>
	 * CAPPLANTA	si l'usuari actiu es un cap de planta 
	 */
	
	@SuppressWarnings("unchecked")
	public String obrirAfegirPrevisioCompte(){				
		this.titol=getText("previsio.gestio.titol");
		errorsComptaXM=(List<String>) session.get("errorsComptaXM");
		session.put("errorsComptaXM", new ArrayList<String>());
		if(tipusOperacio==1){
			previsioActual= rebutModel.obtenirPrevisio(idPrevisioActual);
		}	
		previsioActual.setPeriodeComptable((PeriodeComptable)session.get("periodeComptableActual"));			
		this.comptes=compteModel.obtenirComptesActius();			
		if (usuari.getTipusUsuari().equals(usuari.getAdministrador())){			
			return "administrador";
		}		
		else{
			return "capPlanta";
		}
	}
	/**
	 * Acci que presenta les previsions d'un compte seleccionat
	 * @return 	ADMINISTRADOR si l'usuari actiu es un administrador <br>
	 * CAPPLANTA	si l'usuari actiu es un cap de planta
	 */
	@SuppressWarnings("unchecked")
	public String presentarPrevisionsCompte(){
		this.titol=getText("previsio.gestio.titol");
		errorsComptaXM=(List<String>) session.get("errorsComptaXM");
		session.put("errorsComptaXM", new ArrayList<String>());
		
		previsioActual.setPeriodeComptable(((PeriodeComptable)session.get("periodeComptableActual")));
		previsioActual.setCompte(compteModel.obtenirCompte(idCompteActual));
		session.put("idCompteActual", idCompteActual);
		
		previsionsComptePeriode= rebutModel.obtenirPrevisions(((PeriodeComptable) session.get("periodeComptableActual")).getIdPeriodeComptable(), idCompteActual);
		totalPrevisionsCompte= rebutModel.obtenirTotalPrevisioCompte(previsioActual.getPeriodeComptable().getIdPeriodeComptable(),idCompteActual);		
		if (usuari.getTipusUsuari().equals(usuari.getAdministrador())){				
			return "administrador";
		}		
		else{		
			return "capPlanta";
		}
	}
	/**
	 * Acci que afegeix una previsio a un compte seleccionat
	 * @return 	SUCCESS predeterminat
	 * 
	 */
	public String afegirPrevisioCompte(){		
						
		if(idCompteActual==-1){
			errorsComptaXM.add(getText("rebut.error.compte"));
		}
		if(descripcioActual.equals("")){
			errorsComptaXM.add(getText("rebut.error.descripcio"));
		}
		if(!utilitats.isDouble(valorActual)){
			errorsComptaXM.add(getText("rebut.error.valor"));
		}
				
		if (errorsComptaXM.size()==0){
			previsioActual.setDescripcio(this.descripcioActual);
			previsioActual.setValor(Double.parseDouble(this.valorActual));
			previsioActual.setPeriodeComptable((PeriodeComptable)session.get("periodeComptableActual"));		
			previsioActual.setCompte(compteModel.obtenirCompte(idCompteActual));
			if(rebutModel.add(previsioActual)){
				previsioActual.setDescripcio("");			
				previsioActual.setValor(0.0);
				addActionMessage(getText("previsio.text.inici")+" " +previsioActual.getDescripcio()+" "+getText("previsio.modificat.correctament"));
			}else{
				errorsComptaXM.add(getText("previsio.err.sql.afegir"));
			}
			
			
		}
						
		session.put("errorsComptaXM", errorsComptaXM);
		errorsComptaXM= new ArrayList<String>();							
		return SUCCESS;
	}
	/**
	 * Acci que elimina una previsio d'un compte que existeix en el sistema
	 * @return SUCCESS predeterminat
	 */
	public String eliminarPrevisioCompte(){							
		previsioActual= rebutModel.obtenirPrevisio(idPrevisioActual);	
		//aqui cal instaurar la eliminaci des del confirm
		 
		/*
		if (JOptionPane.showConfirmDialog(null,getText("previsio.eliminar.confirmacio"),getText("form.confirmacio"),JOptionPane.OK_CANCEL_OPTION)==0){
			rebutModel.delete(previsioActual);			
		}
		return SUCCESS;
		*/
		
		session.put("modificarEstat", previsioActual);
		session.put("accio", 0);		
		return SUCCESS;
		
	}
	/**
	 * Acci que refresca les previsions d'un compte seleccionat
	 *  
	 * @return ADMINISTRADOR si l'usuari actiu es un administrador <br>
	 * CAPPLANTA si l'uauari actiu es un cap de planta.
	 */
	@SuppressWarnings("unchecked")
	public String refrescarPrevisionsCompte(){
		errorsComptaXM=(List<String>) session.get("errorsComptaXM");
		session.put("errorsComptaXM", new ArrayList<String>());
		this.idCompteActual= (int) session.get("idCompteActual");		
		previsioActual.setPeriodeComptable(((PeriodeComptable)session.get("periodeComptableActual")));
		previsioActual.setCompte(compteModel.obtenirCompte(idCompteActual));
		previsionsComptePeriode= rebutModel.obtenirPrevisions(((PeriodeComptable) session.get("periodeComptableActual")).getIdPeriodeComptable(), idCompteActual);
		totalPrevisionsCompte= rebutModel.obtenirTotalPrevisioCompte(previsioActual.getPeriodeComptable().getIdPeriodeComptable(),idCompteActual);		
		if (usuari.getTipusUsuari().equals(usuari.getAdministrador())){				
			return "administrador";
		}		
		else{		
			return "capPlanta";
		}
	}

	public int getOpcioMenu() {
		return opcioMenu;
	}

	public void setOpcioMenu(int opcioMenu) {
		this.opcioMenu = opcioMenu;
	}

	public String getTitol() {
		return titol;
	}

	public void setTitol(String titol) {
		this.titol = titol;
	}


	

	


}
