package uoc.tfc.xmartimo.bean.connexio;

import java.io.Serializable;
/**
 * Classe que representa a una persona (SUPER CLASSE)
 * @author Xavier Mart Moret UOC.TFC.J2EE
 *
 */
public class Persona implements Serializable{
	private static final long serialVersionUID = 1L;
	private int idPersona;
	private String document;
	private String nom;
	private String cognom1;
	private String cognom2;
	private String direccio;
	private String ciutat;
	private String telefon;
	private String email;
	private int estat;
	
	/**
	 * Constructor per defecte
	 */
	public Persona(){
		
	}
	/**
	 * Constructor amb 10 parmetres
	 * @param idpersona	identificador Intern		
	 * @param document	identificador extern	
	 * @param nom	Nom de la persona
	 * @param cognom1	Primer cognom de la persona
	 * @param cognom2	Segon cognom de la persona
	 * @param direccio	direcci de la persona
	 * @param ciutat	Ciutat de la persona
	 * @param telefon	Telefon de la persona
	 * @param email	Direccio de correu de la persona
	 * @param estat	Estat de la persona (1=Actiu, 0=innactiu)
	 */
	public Persona(int idpersona, String document, String nom, String cognom1,
			String cognom2, String direccio, String ciutat, String telefon,
			String email, int estat) {
		
		this.idPersona = idpersona;
		this.document = document;
		this.nom = nom;
		this.cognom1 = cognom1;
		this.cognom2 = cognom2;
		this.direccio = direccio;
		this.ciutat = ciutat;
		this.telefon = telefon;
		this.email = email;
		this.estat = estat;
	}
	/**
	 * Accessor de lectura de l'identificador intern
	 * @return the idpersona	 
	 */
	public int getIdPersona() {
		return idPersona;
	}
	/**
	 * Accessor de escriptura de l'indentificador intern
	 * @param idpersona the idpersona to set
	 */
	public void setIdPersona(int idpersona) {
		this.idPersona = idpersona;
	}
	/**
	 * @return the document
	 */
	public String getDocument() {
		return document;
	}
	/**
	 * @param document the document to set
	 */
	public void setDocument(String document) {
		this.document = document;
	}
	/**
	 * @return the nom
	 */
	public String getNom() {
		return nom;
	}
	/**
	 * @param nom the nom to set
	 */
	public void setNom(String nom) {
		this.nom = nom;
	}
	/**
	 * @return the cognom1
	 */
	public String getCognom1() {
		return cognom1;
	}
	/**
	 * @param cognom1 the cognom1 to set
	 */
	public void setCognom1(String cognom1) {
		this.cognom1 = cognom1;
	}
	/**
	 * @return the cognom2
	 */
	public String getCognom2() {
		return cognom2;
	}
	/**
	 * @param cognom2 the cognom2 to set
	 */
	public void setCognom2(String cognom2) {
		this.cognom2 = cognom2;
	}
	/**
	 * @return the direccio
	 */
	public String getDireccio() {
		return direccio;
	}
	/**
	 * Accessor d'escriptura
	 */
	public void setDireccio(String direccio) {
		this.direccio = direccio;
	}
	/**
	 * @return the ciutat
	 */
	public String getCiutat() {
		return ciutat;
	}
	/**
	 * @param ciutat the ciutat to set
	 */
	public void setCiutat(String ciutat) {
		this.ciutat = ciutat;
	}
	/**
	 * @return the telefon
	 */
	public String getTelefon() {
		return telefon;
	}
	/**
	 * @param telefon the telefon to set
	 */
	public void setTelefon(String telefon) {
		this.telefon = telefon;
	}
	/**
	 * @return the email
	 */
	public String getEmail() {
		return email;
	}
	/**
	 * @param email the email to set
	 */
	public void setEmail(String email) {
		this.email = email;
	}
	/**
	 * @return the estat
	 */
	public int getEstat() {
		return estat;
	}
	/**
	 * @param estat the estat to set
	 */
	public void setEstat(int estat) {
		this.estat = estat;
	}
	
	public String toString(){
		return this.nom; 
	}
}
