package uoc.tfc.xmartimo.bean.connexio;

/**
 * Subclasse que representa a un usuari, hereda de la superclasse persona
 * @author Xavier Mart Moret UOC.TFC.J2EE
 *
 */
public class Usuari extends Persona {
	
	private static final long serialVersionUID = 1L;

	private String login;
	private String password;
	private String tipusUsuari;
	/**
	 * Constant que representa a un administrador
	 */
	private final String administrador ="adm";
	/**
	 * Constant que representa a un cap de planta
	 */
	private final String capPlanta="cap";
	
	/**
	 * Constructor per defecte
	 */
	public Usuari() {
		super();
		
	}
	/**
	 * Constructor amb els parmetres de la superClasse
	 * @param idpersona	identificador Intern		
	 * @param document	identificador extern	
	 * @param nom	Nom de la persona
	 * @param cognom1	Primer cognom de la persona
	 * @param cognom2	Segon cognom de la persona
	 * @param direccio	direcci de la persona
	 * @param ciutat	Ciutat de la persona
	 * @param telefon	Telefon de la persona
	 * @param email	Direccio de correu de la persona
	 * @param estat	Estat de la persona (1=Actiu, 0=innactiu)
	 */
	public Usuari(int idpersona, String document, String nom, String cognom1,
			String cognom2, String direccio, String ciutat, String telefon,
			String email, int estat) {
		super(idpersona, document, nom, cognom1, cognom2, direccio, ciutat, telefon,
				email, estat);
		
	}
	/**
	 *  Constructor amb tots els parametres
	 * @param persona	superClasse
	 * @param login	nom descriptiu de l'usuari
	 * @param password	clau de pas de l'usuari
	 * @param tipus	tipus d'usuari. 
	 */
	public Usuari(Persona persona,  String login, String password,String tipus) {			
		super(persona.getIdPersona(),persona.getDocument(),persona.getNom(),persona.getCognom1(),
				persona.getCognom2(),persona.getDireccio(),persona.getCiutat(),persona.getTelefon(),persona.getEmail(),persona.getEstat());		
		this.login = login;
		this.password = password;
		this.tipusUsuari=tipus;
	}
	
	
	/**
	 * @return the login
	 */
	public String getLogin() {
		return login;
	}
	/**
	 * @param login the login to set
	 */
	public void setLogin(String login) {
		this.login = login;
	}
	/**
	 * @return the password
	 */
	public String getPassword() {
		return password;
	}
	/**
	 * @param password the password to set
	 */
	public void setPassword(String password) {
		this.password = password;
	}
	public String getTipusUsuari() {
		return tipusUsuari;
	}
	public void setTipusUsuari(String tipusUsuari) {
		this.tipusUsuari = tipusUsuari;
	}
	public String getAdministrador() {
		return administrador;
	}
	public String getCapPlanta() {
		return capPlanta;
	}
	public String toString(){
		return this.login; 
	}

	
}
