package uoc.tfc.xmartimo.bean.manteniment;

import uoc.tfc.xmartimo.bean.connexio.Persona;
import uoc.tfc.xmartimo.bean.connexio.Usuari;

public class Centre extends Persona {
	
	/**
	 * Subclasse que representa a un centre del sistema. Hereda de la Classe persona
	 */
	private static final long serialVersionUID = 1L;
	
	private Usuari usuari;
	/**
	 * Constructor per defecte
	 */
	public Centre() {
		super();
		
	}
	/**
	 * Constructor amb tots els atributs de la superclasse
	 * @param idpersona	identificador Intern		
	 * @param document	identificador extern	
	 * @param nom	Nom de la persona
	 * @param cognom1	Primer cognom de la persona
	 * @param cognom2	Segon cognom de la persona
	 * @param direccio	direcci de la persona
	 * @param ciutat	Ciutat de la persona
	 * @param telefon	Telefon de la persona
	 * @param email	Direccio de correu de la persona
	 * @param estat	Estat de la persona (1=Actiu, 0=innactiu)
	 * @param usuari	usuari que pertany al centre
	 */
	public Centre(int idpersona, String document, String nom, String cognom1,
			String cognom2, String direccio, String ciutat, String telefon,
			String email, int estat, Usuari usuari) {
		super(idpersona, document, nom, cognom1, cognom2, direccio, ciutat, telefon,
				email, estat);		
		this.setUsuari(usuari);
	}

	public Usuari getUsuari() {
		return usuari;
	}

	public void setUsuari(Usuari usuari) {
		this.usuari = usuari;
	}
	public String toString(){
		return this.getNom();
	}
}
