package uoc.tfc.xmartimo.bean.manteniment;

import java.io.Serializable;
/**
 * Classe que representa a un compte d'explotaci
 * @author Xavier Mart Moret UOC.TFC.J2EE
 *
 */
public class Compte implements Serializable {
	private static final long serialVersionUID = 1L;
	private int idCompte;
	private String codi;
	private String descripcio;
	private int estat;
	/**
	 * Constructor per defecte
	 */
	public Compte(){
		
	}
	/**
	 * Constructor amb tres parmetres
	 * @param codi	Codi del compte
	 * @param descripcio	descripci del compte
	 * @param estat	estat del compte (1=actiu, 0 = innactiu)
	 */
	public Compte(String codi, String descripcio, int estat) {				
		this.codi=codi;
		this.descripcio = descripcio;
		this.setEstat(estat);
	}
	/**
	 * Constructor amb tots els parmetres
	 * @param idCompte	identificador intern
	 * @param codi	codi del compte
	 * @param descripcio	descripci del compte
	 * @param estat	estat del compte (1= actiu, 0=innactiu)
	 */
	public Compte(int idCompte,String codi, String descripcio, int estat) {		
		this.idCompte = idCompte;
		this.codi=codi;
		this.descripcio = descripcio;
		this.setEstat(estat);
	}
	/**
	 * @return the idCompte
	 */
	public int getIdCompte() {
		return idCompte;
	}
	/**
	 * @param idCompte the idCompte to set
	 */
	public void setIdCompte(int idCompte) {
		this.idCompte = idCompte;
	}
	/**
	 * @return the descripcio
	 */
	public String getDescripcio() {
		return descripcio;
	}
	/**
	 * @param descripcio the descripcio to set
	 */
	public void setDescripcio(String descripcio) {
		this.descripcio = descripcio;
	}
	public int getEstat() {
		return estat;
	}
	public void setEstat(int estat) {
		this.estat = estat;
	}
	public String getCodi() {
		return codi;
	}
	public void setCodi(String codi) {
		this.codi = codi;
	}
		
	
	@Override
	public String toString() {
		return codi + " - " + descripcio;				
	}
	
	
	
}
