package uoc.tfc.xmartimo.bean.manteniment;

import java.io.Serializable;
/**
 * Classe que representa a un periode comptable 
 * @author Xavier Mart Moret UOC.TFC.J2EE
 *
 */
public class PeriodeComptable implements Serializable{
	private static final long serialVersionUID = 1L;
	private int idPeriodeComptable;
	private int anyo;
	private int mes;
	private String mesString;
	private Centre centre;
	private boolean estat;
	/**
	 * Constructor per defecte
	 */
	public PeriodeComptable(){
		
	}
	/**
	 * Constructor amb quatre parmetres
	 * @param anyo	any del perode comptable
	 * @param mes	mes del perode comptable
	 * @param centre	centre del perode comptable
	 * @param estat	estat del perode comptable (1=obert, 0=tancat)
	 */
	public PeriodeComptable( int anyo, int mes, Centre centre,
			boolean estat) {				
		this.anyo = anyo;
		this.mes = mes;
		this.centre = centre;
		this.estat = estat;
	}
	/**
	 * Constructor amb cinc parmetres
	 * @param idPeriodeComptable	identificador intern
	 * @param anyo	any del perode comptable
	 * @param mes	mes del perode comptable
	 * @param centre	centre del perode comptable
	 * @param estat	estat del perode comptable (1=obert, 0=tancat)
	 */
	public PeriodeComptable(int idPeriodeComptable, int anyo, int mes, Centre centre,
			boolean estat) {		
		this.setIdPeriodeComptable(idPeriodeComptable);
		this.anyo = anyo;
		this.mes = mes;
		this.centre = centre;
		this.estat = estat;
	}
	
	public int getIdPeriodeComptable() {
		return idPeriodeComptable;
	}
	public void setIdPeriodeComptable(int idPeriodeComptable) {
		this.idPeriodeComptable = idPeriodeComptable;
	}
	/**
	 * @return the anyo
	 */
	public int getAnyo() {
		return anyo;
	}
	/**
	 * @param anyo the anyo to set
	 */
	public void setAnyo(int anyo) {
		this.anyo = anyo;
	}
	/**
	 * @return the mes
	 */
	public int getMes() {
		return mes;
	}
	/**
	 * @param mes the mes to set
	 */
	public void setMes(int mes) {
		this.mes = mes;
	}
	/**
	 * @return the centre
	 */
	public Centre getCentre() {
		return centre;
	}
	/**
	 * @param centre the centre to set
	 */
	public void setCentre(Centre centre) {
		this.centre = centre;
	}
	/**
	 * @return the estat
	 */
	public boolean getEstat() {
		return estat;
	}
	/**
	 * @param estat the estat to set
	 */
	public void setEstat(boolean estat) {
		this.estat = estat;
	}
	public String getMesString() {
		return mesString;
	}
	public void setMesString(String mesString) {
		this.mesString = mesString;
	}
	
	
	

}
