package uoc.tfc.xmartimo.bean.manteniment;

import java.io.Serializable;
/**
 * Classe que representa els comptes d'un periodecomptable
 * @author Xavier Mart Moret UOC.TFC.J2EE
 *
 */
public class PeriodeComptableCompte implements Serializable{
	private static final long serialVersionUID = 1L;
	
	private int idPeriodeComptableCompte;
	private PeriodeComptable periodeComptable=new PeriodeComptable();
	private Compte compte=new Compte();
	private double totalPrevisio;
	private double totalComanda;
	
	/**
	 * Constructor per defecte
	 */
	public PeriodeComptableCompte(){
		
	}
	/**
	 * Constructor amb tots els parmetres
	 * @param idPeriodeComptableCompte	identificador intern
	 * @param periodeComptable	periodecomptable 
	 * @param compte	compte
	 * @param totalPrevisio	total import de les previsions
	 * @param totalComanda	total import de les comandes
	 */
	public PeriodeComptableCompte(int idPeriodeComptableCompte,PeriodeComptable periodeComptable, Compte compte,double totalPrevisio, double totalComanda) {
		super();
		this.idPeriodeComptableCompte=idPeriodeComptableCompte;
		this.periodeComptable =periodeComptable;
		this.compte = compte;
		this.totalPrevisio = totalPrevisio;
		this.totalComanda = totalComanda;
	}
	
	
	/**
	 * @return the periodeComptable
	 */
	public PeriodeComptable getPeriodeComptable() {
		return periodeComptable;
	}
	/**
	 * @param periodeComptable the periodeComptable to set
	 */
	public void setPeriodeComptable(PeriodeComptable periodeComptable) {
		this.periodeComptable = periodeComptable;
	}
	/**
	 * @return the compte
	 */
	public Compte getCompte() {
		return compte;
	}
	/**
	 * @param compte the compte to set
	 */
	public void setCompte(Compte compte) {
		this.compte = compte;
	}
	/**
	 * @return the totalPrevisio
	 */
	public double getTotalPrevisio() {
		return totalPrevisio;
	}
	/**
	 * @param totalPrevisio the totalPrevisio to set
	 */
	public void setTotalPrevisio(double totalPrevisio) {
		this.totalPrevisio = totalPrevisio;
	}
	/**
	 * @return the totalComanda
	 */
	public double getTotalComanda() {
		return totalComanda;
	}
	/**
	 * @param totalComanda the totalComanda to set
	 */
	public void setTotalComanda(double totalComanda) {
		this.totalComanda = totalComanda;
	}
	public int getIdPeriodeComptableCompte() {
		return idPeriodeComptableCompte;
	}
	public void setIdPeriodeComptableCompte(int idPeriodeComptableCompte) {
		this.idPeriodeComptableCompte = idPeriodeComptableCompte;
	}
	

}
