package uoc.tfc.xmartimo.bean.manteniment;

import java.io.Serializable;

import uoc.tfc.xmartimo.bean.connexio.Persona;

/**
 * Classe que representa al provedor
 * @author Xavier Mart Moret UOC.TFC.J2EE
 *
 */
public class Proveidor implements Serializable{
	private static final long serialVersionUID = 1L;
	private int idProveidor;
	private String document;
	private String nom;
	private String cognom1;
	private String cognom2;
	private String direccio;
	private String ciutat;
	private String telefon;
	private String email;
	private Centre centre;
	private int estat;
	/**
	 * Constructor per defecte
	 */
	public Proveidor() {
		this.idProveidor=-1;
		this.centre=new Centre();
		this.centre.setIdPersona(-1);
	}
	/**
	 * Constructor amb tots els parmetres 
	 * @param idProveidor	identificador intern
	 * @param document	identificador extern
	 * @param nom	nom del provedor
	 * @param cognom1	primer cognom del provedor
	 * @param cognom2	segon cognom del provedor
	 * @param direccio	Direcci del provedor
	 * @param ciutat	Ciutat del provedor
	 * @param telefon	Telefon del provedor
	 * @param email	Direcci de correu del prevedor
	 * @param estat	Estat del provedor
	 * @param centre	Centre que pertany el provedor
	 * @param estatProveidor	Estat 
	 */
	public Proveidor(int idProveidor, String document, String nom,
			String cognom1, String cognom2, String direccio, String ciutat,
			String telefon, String email, int estat,Centre centre,int estatProveidor) {
		this.idProveidor=idProveidor;
		this.document = document;
		this.nom = nom;
		this.cognom1 = cognom1;
		this.cognom2 = cognom2;
		this.direccio = direccio;
		this.ciutat = ciutat;
		this.telefon = telefon;
		this.email = email;
		this.centre=centre;
		this.estat=estatProveidor;
	}
	/**
	 * Constructor amb onze parmetres	
	 * @param document	identificador extern
	 * @param nom	nom del provedor
	 * @param cognom1	primer cognom del provedor
	 * @param cognom2	segon cognom del provedor
	 * @param direccio	Direcci del provedor
	 * @param ciutat	Ciutat del provedor
	 * @param telefon	Telefon del provedor
	 * @param email	Direcci de correu del prevedor
	 * @param estat	Estat del provedor
	 * @param centre	Centre que pertany el provedor
	 * @param estatProveidor	Estat
	 */
	public Proveidor( String document, String nom,
			String cognom1, String cognom2, String direccio, String ciutat,
			String telefon, String email, int estat,Centre centre,int estatProveidor) {		
		this.document = document;
		this.nom = nom;
		this.cognom1 = cognom1;
		this.cognom2 = cognom2;
		this.direccio = direccio;
		this.ciutat = ciutat;
		this.telefon = telefon;
		this.email = email;
		this.centre=centre;
		this.estat=estatProveidor;
	}
	public Centre getCentre() {
		return centre;
	}
	public void setCentre(Centre centre) {
		this.centre = centre;
	}
	public int getIdProveidor() {
		return idProveidor;
	}
	public void setIdProveidor(int idProveidor) {
		this.idProveidor = idProveidor;
	}
	/**
	 * @return the document
	 */
	public String getDocument() {
		return document;
	}
	/**
	 * @param document the document to set
	 */
	public void setDocument(String document) {
		this.document = document;
	}
	/**
	 * @return the nom
	 */
	public String getNom() {
		return nom;
	}
	/**
	 * @param nom the nom to set
	 */
	public void setNom(String nom) {
		this.nom = nom;
	}
	/**
	 * @return the cognom1
	 */
	public String getCognom1() {
		return cognom1;
	}
	/**
	 * @param cognom1 the cognom1 to set
	 */
	public void setCognom1(String cognom1) {
		this.cognom1 = cognom1;
	}
	/**
	 * @return the cognom2
	 */
	public String getCognom2() {
		return cognom2;
	}
	/**
	 * @param cognom2 the cognom2 to set
	 */
	public void setCognom2(String cognom2) {
		this.cognom2 = cognom2;
	}
	/**
	 * @return the direccio
	 */
	public String getDireccio() {
		return direccio;
	}
	/**
	 * @param direccio the direccio to set
	 */
	public void setDireccio(String direccio) {
		this.direccio = direccio;
	}
	/**
	 * @return the ciutat
	 */
	public String getCiutat() {
		return ciutat;
	}
	/**
	 * @param ciutat the ciutat to set
	 */
	public void setCiutat(String ciutat) {
		this.ciutat = ciutat;
	}
	/**
	 * @return the telefon
	 */
	public String getTelefon() {
		return telefon;
	}
	/**
	 * @param telefon the telefon to set
	 */
	public void setTelefon(String telefon) {
		this.telefon = telefon;
	}
	/**
	 * @return the email
	 */
	public String getEmail() {
		return email;
	}
	/**
	 * @param email the email to set
	 */
	public void setEmail(String email) {
		this.email = email;
	}
	
	public int getEstat() {
		return estat;
	}
	public void setEstat(int estat) {
		this.estat = estat;
	}
	
	public String toString(){
		return nom + " " +cognom1;
	}
	

}
