package uoc.tfc.xmartimo.bean.rebut;

import uoc.tfc.xmartimo.bean.manteniment.Compte;
import uoc.tfc.xmartimo.bean.manteniment.PeriodeComptable;
import uoc.tfc.xmartimo.bean.manteniment.Proveidor;
/**
 * SubClasse que representa a la comanda, hereda de la superclasse rebut
 * @author Xavier Mart Moret UOC.TFC.J2EE
 *
 */
public class Comanda extends Rebut{

	private static final long serialVersionUID = 1L;
	private int dia;
	private Proveidor proveidor;
	/**
	 * Constructor per defecte
	 */
	public Comanda() {
		super();
	}
	/**
	 * Constructor amb tots els parmetres
	 * @param descripcio	descripcio del rebut
	 * @param periodeComptable	periode comptable del rebut
	 * @param valor	import del rebut
	 * @param compte	compte del rebut
	 * @param dia	dia de la comanda
	 * @param proveidor	provedor de la comanda
	 */
	public Comanda(String descripcio,
			PeriodeComptable periodeComptable, double valor, Compte compte,int dia, Proveidor proveidor) {
		super(descripcio, periodeComptable, valor, compte);
		this.dia=dia;
		this.proveidor=proveidor;
		
	}
	/**
	 * @return the dia
	 */
	public int getDia() {
		return dia;
	}
	/**
	 * @param dia the dia to set
	 */
	public void setDia(int dia) {
		this.dia = dia;
	}
	/**
	 * @return the proveidor
	 */
	public Proveidor getProveidor() {
		return proveidor;
	}
	/**
	 * @param proveidor the proveidor to set
	 */
	public void setProveidor(Proveidor proveidor) {
		this.proveidor = proveidor;
	}
	
}
