package uoc.tfc.xmartimo.bean.rebut;

import java.io.Serializable;

import uoc.tfc.xmartimo.bean.manteniment.Compte;
import uoc.tfc.xmartimo.bean.manteniment.PeriodeComptable;
/**
 * SuperClasse que representa a un rebut
 * @author Xavier Mart Moret UOC.TFC.J2EE
 *
 */
public class Rebut implements Serializable  {
	private static final long serialVersionUID = 1L;
	private int idRebut;
	private String descripcio;
	private PeriodeComptable periodeComptable;
	private double valor;
	private Compte compte;
	/**
	 * Constructor per defecte
	 */
	public Rebut(){
		
	}
	/**
	 * Constructor amb tots els parmetres
	 * @param descripcio	descripcio del rebut
	 * @param periodeComptable	periode comptable del rebut
	 * @param valor	import del rebut
	 * @param compte	compte del rebut
	 */
	public Rebut(String descripcio,
			PeriodeComptable periodeComptable, double valor, Compte compte) {		
		
		this.descripcio = descripcio;
		this.periodeComptable = periodeComptable;
		this.valor = valor;
		this.compte = compte;
	}
	/**
	 * @return the idRebut
	 */
	public int getIdRebut() {
		return idRebut;
	}
	/**
	 * @param idRebut the idRebut to set
	 */
	public void setIdRebut(int idRebut) {
		this.idRebut = idRebut;
	}
	/**
	 * @return the descripcio
	 */
	public String getDescripcio() {
		return descripcio;
	}
	/**
	 * @param descripcio the descripcio to set
	 */
	public void setDescripcio(String descripcio) {
		this.descripcio = descripcio;
	}
	/**
	 * @return the periodeComptable
	 */
	public PeriodeComptable getPeriodeComptable() {
		return periodeComptable;
	}
	/**
	 * @param periodeComptable the periodeComptable to set
	 */
	public void setPeriodeComptable(PeriodeComptable periodeComptable) {
		this.periodeComptable = periodeComptable;
	}
	/**
	 * @return the valor
	 */
	public double getValor() {
		return valor;
	}
	/**
	 * @param valor the valor to set
	 */
	public void setValor(double valor) {
		this.valor = valor;
	}
	/**
	 * @return the compte
	 */
	public Compte getCompte() {
		return compte;
	}
	/**
	 * @param compte the compte to set
	 */
	public void setCompte(Compte compte) {
		this.compte = compte;
	}
	public String toString(){
		return  this.descripcio + ". Import: " + this.valor ;     
	}
	
	
}
